var GlobalAnkangLayer = null;
var AnkangLayer = SmallLayer.extend({
    star_ad:null,
    ctor:function(){
        GlobalADIndex++;
        this._super();
        GlobalAnkangLayer = this;
        if (AD_ENABLE && ARRY_AD_IN && ARRY_AD_IN.length) {
            GlobalADIndex = (GlobalADIndex++)  % ARRY_AD_IN.length;
            this.star_ad = new StarAdLayer(ARRY_AD_IN[GlobalADIndex]);
            this.star_ad.setGlobalZOrder(65535);
            this.star_ad.x = cc.winSize.width - 85;
            this.star_ad.y = - 15;
            this.addChild(this.star_ad, 65535);
        }

        popSceneMenu(this);
        recvCustomEvent("goto_ankang_next_play",function(){
            unRegistCustomEvent("goto_ankang_next_play");
            closeStarAd(this.star_ad);
            this.star_ad = null;
            this.add8ankang();
        }.bind(this));
    },
    addRandTrashAndBobble:function(){
      this.schedule(function(){
            addTrash(this.background,cc.p(100,-1));
        },10+getRand1ToN(10),cc.REPEAT_FOREVER,3);

        this.schedule(function(){
            addWateBobble(this.background,cc.p(800,-1));
        },5+getRand1ToN(10),cc.REPEAT_FOREVER,2);
    },
    loadRes:function(){
        cc.log("loadRes-Ankang");
        var self = this;
        this.addChild(new CustomLoadingLayer("ankang",4,function(){
            cc.log("current loaded ankang.pvr.ccz");
            self.addAnkang();
            //self.addXiaoyu();
            self.addShuimu();
        }));
    },
    addShuimu:function(){
        cc.log("add-shuimu");
        this.shuimu = [];
        for(var i = 0;i < 4;i ++){
            this.shuimu[i] = new cc.Sprite("#shayu-shuimu1.png");
            this.shuimu[i].setScale(0.5+i*0.1);
            this.shuimu[i].setPosition(cc.p(400+i*140,500-i*100));
            this.addChild(this.shuimu[i]);
            this.shuimu[i].runAction(cc.repeatForever(cc.sequence(newAnimationCreate(30,"shayu-shuimu",0.05,1,false),cc.delayTime(0.6))));
        }
        this.scheduleUpdate();
    },
    addBackground: function () {
        this.background = createStaticNode("res/ankang/background.png", this, cc.p(GW2, GH2), 0);
        resetScale(this.background);
        createShakeNode("res/ankang/texture/grass1.png",this,cc.p(850,170),5, 5, cc.size(15, 100), 3, 10);
        createShakeNode("res/ankang/texture/grass2.png",this,cc.p(1000,170),5, 5, cc.size(15, 100), 3, 10);
        createShakeNode("res/ankang/texture/grass3.png",this,cc.p(300,110),5, 5, cc.size(15, 100), 3, 10);
        this.foreground = createStaticNode("res/ankang/texture/stone2.png", this, cc.p(GW2, GH2), 10);
        this.addRandTrashAndBobble();
    },
    addStatic:function(){
        this.addBackground();
    },
    update:function(dt){
        for(var i = 0;i < 4;i ++){
            this.shuimu[i].x -= 10*dt;
            this.shuimu[i].y += 13*dt;
            if(this.shuimu[i].y > 700){
                this.shuimu[i].setPosition(cc.p(getRand1ToN(cc.winSize.width - 100)+100,-80));
            }
        }
    },
    addDynamic:function(){
        cc.log("addDynamic-Ankang");
    },
    addXiaoyu:function(){
        this.xiaoyu = createStaticNode("res/ankang/texture/ankang-xiaoyu1.png",this,cc.p(-50,GH2-80),100);
        recvCustomEvent("tell_xiaoyu_disappear",function(){
        unRegistCustomEvent("tell_xiaoyu_disappear");
            this.setVisible(false);
        }.bind(this.xiaoyu));
        this.xiaoyu.runAction(cc.sequence(cc.moveTo(2,cc.p(GW2-210,GH2-80)).easing(cc.easeBackInOut()),cc.callFunc(function(){
            sendCustomEvent("tell_ankang_eat_xiaoyu");
        })));
        this.xiaoyu.runAction(animationCreate(9,"res/ankang/texture/ankang-xiaoyu",1,0.1,-1,false));
    },
    addAnkang:function(){
        this.ankang = new AnkangSprite("#ankang-talk1.png",1);
        this.ankang.touchable = false;
        this.ankang.speakOver = false;
        var self = this;
        recvCustomEvent("tell_ankang_eat_xiaoyu",function(){
        unRegistCustomEvent("tell_ankang_eat_xiaoyu");
            cc.log("recv ankang eat xiaoyu signal");
            if(self.ankang)
                self.ankang.stopAllActions();
            self.ankang.runAction(cc.sequence(
                cc.spawn(newAnimationCreate(12,"ankang-eat",0.1,1,false),
                    cc.sequence(cc.delayTime(0.5),cc.callFunc(function(){
                        sendCustomEvent("tell_xiaoyu_disappear");
                }))),
                // cc.spawn(newAnimationCreate(7,"ankang-laugh",0.1,100,false),
                //     cc.sequence(cc.delayTime(2),cc.callFunc(function(){
                //         sendCustomEvent("goto_ankang_next_play");
                // }))),
                newAnimationCreate(7,"ankang-talk",0.04,1,false),
                newAnimationCreate(7,"ankang-laugh",0.08,2,false),
                cc.spawn(newAnimationCreate(24,"ankang-talk",0.1,1000,false),
                    cc.sequence(cc.moveBy(3,-1000,0).easing(cc.easeBackIn()),cc.callFunc(function () {
                        sendCustomEvent("goto_ankang_next_play");
                    })))));
        }.bind(self));
        this.addChild(this.ankang,120);
        this.ankang.setPosition(cc.p(GW+700,GH2));
        this.ankang.runAction(cc.spawn(cc.moveTo(1.3,cc.p(GW2,GH2)).easing(cc.easeCircleActionInOut()),newAnimationCreate(24,"ankang-talk",0.1,1000,false)));

        this.scheduleOnce(function(){
            this.ankang.speakOver = true;
            this.addXiaoyu();
        },3.5);
    },
    add8ankang:function(){
        this.ankang8_normal = [];
        this.ankang8_click = [];
        for(var i = 0;i < 8;i ++){
            if(0==i || 3==i || 5==i || 6 ==i){
                this.ankang8_click[i] = new AnkangClick("#ankang-click1.png",false,i);
                this.ankang8_click[i].setPosition(Config_Play.ankang.ankang8pos[i]);
                this.ankang8_click[i].enable_ = false;
            }else{
                this.ankang8_click[i] = new AnkangClick("#ankang-click1.png",true,i);
                this.ankang8_click[i].setFlippedX(true);
                this.ankang8_click[i].setPosition(Config_Play.ankang.ankang8pos[i]);
            }
            this.addChild(this.ankang8_click[i],100);
            this.ankang8_click[i].setVisible(false);
        }

        for(var i = 0;i < 8;i ++){
            if(0==i || 3==i || 5==i || 6 ==i){
                this.ankang8_normal[i] = new AnkangBase("#ankang-normal1.png",i);
                this.ankang8_normal[i].setPosition(cc.p(Config_Play.ankang.ankang8pos[i].x - GW*2/3,Config_Play.ankang.ankang8pos[i].y));
            }else{
                this.ankang8_normal[i] = new AnkangBase("#ankang-normal1.png",i);
                this.ankang8_normal[i].setFlippedX(true);
                this.ankang8_normal[i].setPosition(cc.p(Config_Play.ankang.ankang8pos[i].x + GW*2/3,Config_Play.ankang.ankang8pos[i].y));
            }
            this.addChild(this.ankang8_normal[i],100);
            this.ankang8_normal[i].runAction(newAnimationCreate(13,"ankang-normal",0.1,100,false));
        }

        for(var i = 0;i < 8;i ++){
            if(0==i || 3==i || 5==i || 6 ==i) {
                this.ankang8_normal[i].runAction(cc.sequence(cc.moveBy(2,GW*2/3,0),cc.callFunc(function(){

                })));
            }else{
                this.ankang8_normal[i].runAction(cc.moveBy(2,-GW*2/3,0));
            }
        }

        this.scheduleOnce(function(){
            for(var i = 0;i < 8;i ++){
                this.ankang8_click[i].enable_ = true;
            }
        },2);
    },
    unregisterAllEvents:function(){
        cc.eventManager.removeCustomListeners("tell_ankang_show_lamp");
        cc.eventManager.removeCustomListeners("tell_ankang_close_lamp");
    },
    releaseRes:function(){
        ddStopAllAudios();
        this.unregisterAllEvents();
        this.cleanScene();
    },
    cleanScene:function(){
        if(this.star_ad){
            closeStarAd(this.star_ad);
        }
        this.unscheduleAllCallbacks();
        this.ankang.stopAllActions();

        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
    }
});

var AnkangScene = cc.Scene.extend({
    ctor:function () {
        this._super();
        ddStopAllAudios();
        umengEvent("fish_type", "AnKang");
        this.scheduleOnce(function(){
            cc.audioEngine.setMusicVolume(1);
            cc.audioEngine.setEffectsVolume(1);
            ddPlayEffect("music","res/ankang/audio/music/ankang.mp3",false);
        },1.3);

        var layer = new AnkangLayer();
        this.addChild(layer);
    },
    onEnter:function(){
        this._super();
        ddStopAllAudios();
        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
    }
});