var Enter = cc.Sprite.extend({
    couldTouch:null,
    touchdelta:null,
    ctor:function(path,name){
        this._super(path);
        this.entername = name;
        this.couldTouch = true;
        this.touchdelta = cc.p(0,0);
        registerTouchEventOneByOne(this,false,this);
    },
    onTouchBegan:function(touch,event){
        var self = this;
        var target = event.getCurrentTarget();
        var locationInNode = target.convertToNodeSpace(touch.getLocation());
        self.touchdelta = locationInNode;
        var s = target.getContentSize();
        var rect = cc.rect(0, 0, s.width, s.height);
        if (cc.rectContainsPoint(rect, locationInNode) && self.couldTouch) {
            self.couldTouch = false;
            cc.log("touched began");
            GlobalDelta = GlobalDadituLayer.scrollView.getInnerContainer().getPositionY();
            return true;
        }else{
            self.touchdelta = cc.p(0,0);
            return false;
        }
    },
    onTouchEnded: function (touch, event) {
        var self = this;
        if(Math.abs(GlobalDelta - GlobalDadituLayer.scrollView.getInnerContainer().getPositionY()) < 10){
            GlobalDelta = 0;
            cc.audioEngine.setMusicVolume(1);
            cc.audioEngine.setEffectsVolume(1);
            self.scheduleOnce(function(){
                self.couldTouch = true;
            },0.3);
            switch (this.entername){
               case "jing" :
                    var lastpoint = event.getCurrentTarget().convertToNodeSpace(touch.getLocation());
                    if(Math.sqrt(Math.pow(Math.abs(lastpoint.x - self.touchdelta.x),2) + Math.pow(Math.abs(lastpoint.y - self.touchdelta.y),2)) < 10){
                         self.touchdelta = cc.p(0,0);
                         cc.director.pushScene(new JingyuScene());
                     }
               break;
               case "haixing":
                    cc.director.pushScene(new HaixingScene());
               break;
               case "shayu":
                    cc.director.pushScene(new ShaYuScene());
                    break;
               case "haigui":
                    cc.director.pushScene(new HaiguiScene());
                    break;
               case "ankang":
                    var lastpoint = event.getCurrentTarget().convertToNodeSpace(touch.getLocation());
                    if(Math.sqrt(Math.pow(Math.abs(lastpoint.x - self.touchdelta.x),2) + Math.pow(Math.abs(lastpoint.y - self.touchdelta.y),2)) < 10){
                        self.touchdelta = cc.p(0,0);
                        cc.director.pushScene(new AnkangScene());
                    }
                    break;
               default:
                    break;
            }
        }else{
            self.couldTouch = true;
            self.touchdelta = cc.p(0,0);
        }
        GlobalDelta = 0;
    }
});