var GlobalHaiguiLayer = null;
var GlobalHaiguiCouldTouch = null;
var HaiguiLayer = SmallLayer.extend({
	star_ad:null,
	firstEnter:null,
	currentIndex:null,
	positionIndex:null,
	ctor:function(){
		GlobalADIndex++;
		this._super();
		GlobalHaiguiLayer = this;
		GlobalHaiguiCouldTouch = false;
		this.firstEnter = true;
		this.currentIndex = 0;
		this.positionIndex = 0;
		if (AD_ENABLE && ARRY_AD_IN && ARRY_AD_IN.length) {
		    GlobalADIndex = (GlobalADIndex++)  % ARRY_AD_IN.length;
		    this.star_ad = new StarAdLayer(ARRY_AD_IN[GlobalADIndex]);
		    this.star_ad.setGlobalZOrder(65535);
		    this.star_ad.x = cc.winSize.width - 85;
		    this.star_ad.y = - 15;
		    this.addChild(this.star_ad, 65535);
		}
	},
	addRandTrashAndBobble:function(){
		this.schedule(function(){
			addTrash(this.background,cc.p(100,-1));
		},10+getRand1ToN(10),cc.REPEAT_FOREVER,3);

		this.schedule(function(){
			addWateBobble(this.background,cc.p(800,-1));
		},5+getRand1ToN(10),cc.REPEAT_FOREVER,2);
	},
	loadRes:function(){
		var self = this;

		this.background = createStaticNode("res/haigui/texture/background.png", this, cc.p(cc.winSize.width/2,cc.winSize.height/2), 0, 1);
		resetScale(this.background);
		this.addRandTrashAndBobble();
		this.shitoushuicao = [];
		var shitoushuicaoZOrder = [30,10,40,10,10,30];
		var shitoushuicaoName = ["shitou1","shitou2","shitou3","shuicao1","shuicao2","shuicao3"];
		var shitoushuicaoPos = [cc.p(105,260),cc.p(1000,250),cc.p(950,190),cc.p(300,40),cc.p(980,200),cc.p(900,150)];
		for(var i = 0;i < 6;i ++){
			createStaticNode("res/haigui/texture/"+shitoushuicaoName[i]+".png", this, shitoushuicaoPos[i], shitoushuicaoZOrder[i], 1);
		}

		this.addChild(new CustomLoadingLayer("haigui",7,function(){
			cc.log("current loaded haigui.pvr.ccz");
			this.preloadAnimation();
			this.addTextures();
			popSceneMenu(this);
		}.bind(this)));
	},
	preloadAnimation:function(){
		this.shensuotouEffectAction = cc.callFunc(function(){ddPlayEffect("effect", "res/haigui/audio/effect/shentousuotou.mp3", false)}.bind(this));
		this.youzouEffectAction = cc.callFunc(function(){ddPlayEffect("effect", "res/haigui/audio/effect/youzou.mp3", false)}.bind(this));
		this.shengdanEffectAction = cc.callFunc(function(){ddPlayEffect("effect", "res/haigui/audio/effect/shengdan.mp3", false)}.bind(this));
		this.dashanEffectAction = cc.callFunc(function(){ddPlayEffect("effect", "res/haigui/audio/effect/dashan.mp3", false)}.bind(this));
		this.daqiangEffectAction = cc.callFunc(function(){ddPlayEffect("effect", "res/haigui/audio/effect/daqiang.mp3", false)}.bind(this));
		this.chouyanEffectAction = cc.callFunc(function(){ddPlayEffect("effect", "res/haigui/audio/effect/chouyan.mp3", false)}.bind(this));

		this.chuanzhang_moren = newAnimationCreate(Config_Play.haigui.ani_info.haiguichuanzhang.moren.f_number, 
				"haiguichuanzhang_moren", Config_Play.haigui.ani_info.haiguichuanzhang.moren.f_time,65535 , false);
		this.chuanzhang_chouyan = cc.spawn(newAnimationCreate(Config_Play.haigui.ani_info.haiguichuanzhang.chouyan.f_number, 
				"haiguichuanzhang_chouyan", Config_Play.haigui.ani_info.haiguichuanzhang.chouyan.f_time,1 , false),this.chouyanEffectAction);
		this.chuanzhang_shentou = cc.spawn(newAnimationCreate(Config_Play.haigui.ani_info.haiguichuanzhang.shentou.f_number, 
				"haiguichuanzhang_shentou", Config_Play.haigui.ani_info.haiguichuanzhang.shentou.f_time,1 , false),this.shensuotouEffectAction);
		this.chuanzhang_suotou = cc.spawn(newAnimationCreate(Config_Play.haigui.ani_info.haiguichuanzhang.suotou.f_number, 
				"haiguichuanzhang_suotou", Config_Play.haigui.ani_info.haiguichuanzhang.suotou.f_time,1 , false),this.shensuotouEffectAction);

		this.haidao_moren = newAnimationCreate(Config_Play.haigui.ani_info.haiguihaidao.moren.f_number, 
				"haiguihaidao_moren", Config_Play.haigui.ani_info.haiguihaidao.moren.f_time,65535 , false);
		this.haidao_daqiang = cc.spawn(cc.sequence(cc.delayTime(0.1),this.daqiangEffectAction),newAnimationCreate(Config_Play.haigui.ani_info.haiguihaidao.daqiang.f_number, 
				"haiguihaidao_daqiang", Config_Play.haigui.ani_info.haiguihaidao.daqiang.f_time,1 , false));

		this.haidao_shentou = cc.spawn(newAnimationCreate(Config_Play.haigui.ani_info.haiguihaidao.shentou.f_number, 
				"haiguihaidao_shentou", Config_Play.haigui.ani_info.haiguihaidao.shentou.f_time,1 , false),this.shensuotouEffectAction);
		this.haidao_suotou = cc.spawn(newAnimationCreate(Config_Play.haigui.ani_info.haiguihaidao.suotou.f_number, 
				"haiguihaidao_suotou", Config_Play.haigui.ani_info.haiguihaidao.suotou.f_time,1 , false),this.shensuotouEffectAction);

		this.shengdan_moren = newAnimationCreate(Config_Play.haigui.ani_info.haiguishengdan.moren.f_number, 
				"haiguishengdan_moren", Config_Play.haigui.ani_info.haiguishengdan.moren.f_time,65535 , false);
		this.shengdan_rengbaoguo = cc.spawn(cc.sequence(cc.delayTime(0.1),this.shengdanEffectAction),newAnimationCreate(Config_Play.haigui.ani_info.haiguishengdan.rengbaoguo.f_number, 
				"haiguishengdan_rengbaoguo", Config_Play.haigui.ani_info.haiguishengdan.rengbaoguo.f_time,1 , false));


		this.shengdan_shentou = cc.spawn(newAnimationCreate(Config_Play.haigui.ani_info.haiguishengdan.shentou.f_number, 
				"haiguishengdan_shentou", Config_Play.haigui.ani_info.haiguishengdan.shentou.f_time,1 , false),this.shensuotouEffectAction);
		this.shengdan_suotou = cc.spawn(newAnimationCreate(Config_Play.haigui.ani_info.haiguishengdan.suotou.f_number, 
				"haiguishengdan_suotou", Config_Play.haigui.ani_info.haiguishengdan.suotou.f_time,1 , false),this.shensuotouEffectAction);

		this.shenshi_moren = newAnimationCreate(Config_Play.haigui.ani_info.haiguishenshi.moren.f_number, 
				"haiguishenshi_moren", Config_Play.haigui.ani_info.haiguishenshi.moren.f_time,65535 , false);
		this.shenshi_dasan = cc.spawn(cc.sequence(cc.delayTime(0.2),this.dashanEffectAction),newAnimationCreate(Config_Play.haigui.ani_info.haiguishenshi.dasan.f_number, 
				"haiguishenshi_dasan", Config_Play.haigui.ani_info.haiguishenshi.dasan.f_time,1 , false));


		this.shenshi_shentou = cc.spawn(newAnimationCreate(Config_Play.haigui.ani_info.haiguishenshi.shentou.f_number, 
				"haiguishenshi_shentou", Config_Play.haigui.ani_info.haiguishenshi.shentou.f_time,1 , false),this.shensuotouEffectAction);
		this.shenshi_suotou = cc.spawn(newAnimationCreate(Config_Play.haigui.ani_info.haiguishenshi.suotou.f_number, 
				"haiguishenshi_suotou", Config_Play.haigui.ani_info.haiguishenshi.suotou.f_time,1 , false),this.shensuotouEffectAction);

		this.yuanshi_moren = newAnimationCreate(Config_Play.haigui.ani_info.haiguiyuanshi.moren.f_number, 
				"haiguiyuanshi_moren", Config_Play.haigui.ani_info.haiguiyuanshi.moren.f_time,65535 , false);
		this.yuanshi_moren_zou = newAnimationCreate(Config_Play.haigui.ani_info.haiguiyuanshi.moren.f_number, 
				"haiguiyuanshi_moren", Config_Play.haigui.ani_info.haiguiyuanshi.moren.f_time,2 , false);
		this.yuanshi_shentou = cc.spawn(newAnimationCreate(Config_Play.haigui.ani_info.haiguiyuanshi.shentou.f_number, 
				"haiguiyuanshi_shentou", Config_Play.haigui.ani_info.haiguiyuanshi.shentou.f_time,1 , false),this.shensuotouEffectAction);
		this.yuanshi_suotou = cc.spawn(newAnimationCreate(Config_Play.haigui.ani_info.haiguiyuanshi.suotou.f_number, 
				"haiguiyuanshi_suotou", Config_Play.haigui.ani_info.haiguiyuanshi.suotou.f_time,1 , false),this.shensuotouEffectAction);

		this.haiguicantouchAction = cc.callFunc(function(){this.setHaiguiTouchable(true)}.bind(this));
		this.haiguicannottouchAction = cc.callFunc(function(){this.setHaiguiTouchable(false)}.bind(this));

		this.retainActions();
	},
	retainActions:function(){
		this.shensuotouEffectAction.retain();
		this.youzouEffectAction.retain();
		this.shengdanEffectAction.retain();
		this.dashanEffectAction.retain();
		this.daqiangEffectAction.retain();
		this.chouyanEffectAction.retain();

		this.chuanzhang_chouyan.retain();
		this.chuanzhang_moren.retain();
		this.chuanzhang_shentou.retain();
		this.chuanzhang_suotou.retain();

		this.haidao_daqiang.retain();
		this.haidao_moren.retain();
		this.haidao_shentou.retain();
		this.haidao_suotou.retain();

		this.shengdan_rengbaoguo.retain();
		this.shengdan_moren.retain();
		this.shengdan_shentou.retain();
		this.shengdan_suotou.retain();

		this.shenshi_dasan.retain();
		this.shenshi_moren.retain();
		this.shenshi_shentou.retain();
		this.shenshi_suotou.retain();

		this.yuanshi_moren.retain();
		this.yuanshi_moren_zou.retain();
		this.yuanshi_shentou.retain();
		this.yuanshi_suotou.retain();

		this.haiguicantouchAction.retain();
		this.haiguicannottouchAction.retain();
	},
	releaseActions:function(){
		this.shensuotouEffectAction.release();
		this.youzouEffectAction.release();
		this.shengdanEffectAction.release();
		this.dashanEffectAction.release();
		this.daqiangEffectAction.release();
		this.chouyanEffectAction.release();

		this.chuanzhang_chouyan.release();
		this.chuanzhang_moren.release();
		this.chuanzhang_shentou.release();
		this.chuanzhang_suotou.release();

		this.haidao_daqiang.release();
		this.haidao_moren.release();
		this.haidao_shentou.release();
		this.haidao_suotou.release();

		this.shengdan_rengbaoguo.release();
		this.shengdan_moren.release();
		this.shengdan_shentou.release();
		this.shengdan_suotou.release();

		this.shenshi_dasan.release();
		this.shenshi_moren.release();
		this.shenshi_shentou.release();
		this.shenshi_suotou.release();

		this.yuanshi_moren.release();
		this.yuanshi_moren_zou.release();
		this.yuanshi_shentou.release();
		this.yuanshi_suotou.release();

		this.haiguicantouchAction.release();
		this.haiguicannottouchAction.release();
	},
	addShuimu:function(){
		cc.log("add-shuimu");
		this.shuimu = [];
		for(var i = 0;i < 4;i ++){
			this.shuimu[i] = new cc.Sprite("#shuimu1.png");
			this.shuimu[i].setScale(0.5+i*0.1);
			this.shuimu[i].setOpacity(100);
			this.shuimu[i].setPosition(cc.p(getRand1ToN(cc.winSize.width - 100)+100,-180+i*80));
			this.addChild(this.shuimu[i]);
			this.shuimu[i].runAction(cc.repeatForever(cc.sequence(newAnimationCreate(30,"shuimu",0.05,1,false))));
		}
		this.scheduleUpdate();
	},
	update:function(dt){
		for(var i = 0;i < 4;i ++){
			this.shuimu[i].x -= 10*dt;
			this.shuimu[i].y += 13*dt;
			if(this.shuimu[i].y > 700){
				this.shuimu[i].setPosition(cc.p(getRand1ToN(cc.winSize.width - 100)+100,-80));
			}
		}
	},
	addTextures:function(){
		this.addShuimu();
		
		this.haigui = new HaiguiSprite("#haiguiyuanshi_moren1.png");		
		this.addChild(this.haigui,11);
		this.haigui.setPosition(Config_Play.haigui.startPosition);
		this.haigui.setScale(Config_Play.haigui.scale);
		this.haigui.runAction(this.yuanshi_moren);

		this.item0 = cc.sequence(
				this.haiguicannottouchAction,
				this.yuanshi_suotou,
				cc.callFunc(function(){this.haigui.setPosition(this.positionArray[1]);}.bind(this)),
				this.shengdan_shentou,
				this.haiguicantouchAction,
				this.shengdan_moren
		);
		this.item05 = cc.sequence(
				this.haiguicannottouchAction,
				this.shengdan_rengbaoguo,
				this.haiguicantouchAction,
				this.shengdan_moren
		);
		this.item1 = cc.sequence(
				this.haiguicannottouchAction,
				this.shengdan_suotou,
				cc.callFunc(function(){this.haigui.setPosition(this.positionArray[2]);}.bind(this)),
				this.haidao_shentou,
				this.haiguicantouchAction,
				this.haidao_moren
		);
		this.item15 = cc.sequence(
				this.haiguicannottouchAction,
				this.haidao_daqiang,
				this.haiguicantouchAction,
				this.haidao_moren
		);
		this.item2 = cc.sequence(
				this.haiguicannottouchAction,
				this.haidao_suotou,
				cc.callFunc(function(){this.haigui.setPosition(this.positionArray[3]);}.bind(this)),
				this.shenshi_shentou,
				this.haiguicantouchAction,
				this.shenshi_moren
		);
		this.item25 = cc.sequence(
				this.haiguicannottouchAction,
				this.shenshi_dasan,
				this.haiguicantouchAction,
				this.shenshi_moren
		);
		this.item3 = cc.sequence(
				this.haiguicannottouchAction,
				this.shenshi_suotou,
				cc.callFunc(function(){this.haigui.setPosition(this.positionArray[4]);}.bind(this)),
				this.chuanzhang_shentou,
				this.haiguicantouchAction,
				this.chuanzhang_moren
		);
		this.item35 = cc.sequence(
				this.haiguicannottouchAction,
				this.chuanzhang_chouyan,
				this.haiguicantouchAction,
				this.chuanzhang_moren
		);
		this.item4 = cc.sequence(
				this.haiguicannottouchAction,
				this.chuanzhang_suotou,
				cc.callFunc(function(){this.haigui.setPosition(this.positionArray[0]);}.bind(this)),
				this.yuanshi_shentou,
				cc.spawn(this.yuanshi_moren_zou,cc.moveTo(2.5, Config_Play.haigui.endPosition),this.youzouEffectAction),
				cc.callFunc(function(){
					this.shuffleGame();
				}.bind(this))
		);
		this.item0.retain();
		this.item05.retain();
		this.item1.retain();
		this.item15.retain();
		this.item2.retain();
		this.item25.retain();
		this.item3.retain();
		this.item35.retain();
		this.item4.retain();
		this.actionArray = [this.item0,this.item05,this.item1,this.item15,this.item2,this.item25,this.item3,this.item35,this.item4];	
		this.shuffleGame();
	},
	releaseItems:function(){
	    this.item0.release();
        this.item05.release();
        this.item1.release();
        this.item15.release();
        this.item2.release();
        this.item25.release();
        this.item3.release();
        this.item35.release();
        this.item4.release();
	},
	setHaiguiTouchable:function(couldTouch){
		GlobalHaiguiCouldTouch = couldTouch;
	},
	shuffleGame:function(){
		this.currentIndex = 0;
		if(this.firstEnter){
			this.firstEnter = false;
			this.haigui.stopAllActions();
			this.haigui.setPosition(Config_Play.haigui.startPosition);
			this.haigui.runAction(
					cc.spawn(
							cc.callFunc(function(){ddPlayEffect("effect", "res/haigui/audio/effect/youzou.mp3", false)}.bind(this)),
							cc.sequence(
									cc.moveTo(2.5, Config_Play.haigui.playPosition),
									cc.callFunc(function(){ddPlayEffect("music", "res/haigui/audio/music/haigui.mp3", false)}.bind(this)),
									cc.delayTime(6),
									cc.callFunc(function(){this.setHaiguiTouchable(true);}.bind(this))  
							),        
							this.yuanshi_moren  
					)
			);
		}else{
			this.haigui.stopAllActions();
			this.haigui.setPosition(Config_Play.haigui.startPosition);
			this.haigui.runAction(
					cc.spawn(
							cc.callFunc(function(){ddPlayEffect("effect", "res/haigui/audio/effect/youzou.mp3", false)}.bind(this)),
							cc.sequence(
									cc.moveTo(2.5, Config_Play.haigui.playPosition),
									cc.callFunc(function(){this.setHaiguiTouchable(true);}.bind(this))  
							),        
							this.yuanshi_moren  
					)
			);
		}
	},
	gotoNextZhuangban:function(){
		this.haigui.stopAllActions();
		this.haigui.runAction(this.actionArray[this.currentIndex]);
	},
	addStatic:function(){
		this.positionArray = [
		                      cc.p(Config_Play.haigui.playPosition.x,Config_Play.haigui.playPosition.y),
		                      cc.p(Config_Play.haigui.playPosition.x-30,Config_Play.haigui.playPosition.y-31),
		                      cc.p(Config_Play.haigui.playPosition.x-21,Config_Play.haigui.playPosition.y-25),
		                      cc.p(Config_Play.haigui.playPosition.x-67,Config_Play.haigui.playPosition.y-50),
		                      cc.p(Config_Play.haigui.playPosition.x-48,Config_Play.haigui.playPosition.y+13)];
	},
	addDynamic:function(){

	},
	unregisterAllEvents:function(){
	},
	releaseRes:function(){
		ddStopAllAudios();
		this.unregisterAllEvents();
		this.cleanScene();
	},
	cleanScene:function(){
		if(this.star_ad){
		    closeStarAd(this.star_ad);
		}
		this.unscheduleAllCallbacks();

		this.releaseActions();
		this.releaseItems();

		cc.textureCache.removeAllTextures();
		cc.spriteFrameCache.removeSpriteFrames();
	}
});






var HaiguiScene = cc.Scene.extend({
	ctor:function () {
		this._super();
		ddStopAllAudios();
		umengEvent("fish_type", "HaiGui");
		this.scheduleOnce(function(){
			cc.audioEngine.setMusicVolume(1);
			cc.audioEngine.setEffectsVolume(1);
//			ddPlayEffect("music","res/ankang/audio/music/ankang.mp3",false);
		},1.3);

		var layer = new HaiguiLayer();
		this.addChild(layer);
	},
	onEnter:function(){
		this._super();
		ddStopAllAudios();
		cc.textureCache.removeAllTextures();
		cc.spriteFrameCache.removeSpriteFrames();
	}
});
