var HaixingBase = cc.Sprite.extend({
    listener:null,
    couldTouch:null,
    ctor:function(path){
        this._super(path);
        this.couldTouch = true;
        this.addListener();
    },
    addListener:function(){
        var self = this;
        this.sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                self.tool_select = null;
                self.menu_select = null;
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());

                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode) && self.couldTouch) {
                    if(parseInt(GlobalHaixingLayer.gridLabel.getString()) > Config_Play.haixing.grade[GlobalHaixingGrade].needClicked){
                        cc.log("完成一个等级了");
                        GlobalHaixingGrade++;
                        if(GlobalHaixingGrade <= 4) {
                            GlobalHaixingLayer.staticPic.setTexture("res/haixing/texture/"+Config_Play.haixing.colors[GlobalHaixingGrade]+".png");
                            ddPlayEffect("effect", "res/haixing/audio/effect/" + Config_Play.haixing.colors[GlobalHaixingGrade] + ".mp3", false);
                            GlobalHaixingLayer.gridLabel.setString("0");
                            // GlobalHaixingLayer.emitter_high.stopEmit();
                            // GlobalHaixingLayer.emitter_low.stopEmit();

                            GlobalHaixingLayer.changeEmitter(GlobalHaixingGrade);

                        }else{
                            GlobalHaixingLayer.gridLabel.setString("");
                            cc.log("五个等级全完成了，退回到大地图1");
                            GlobalHaixingLayer.staticPic.setVisible(false);

                            var size = cc.winSize;
                            var particleSystem = new cc.ParticleSystem("res/haixing/texture/demo6.plist");
                            particleSystem.setGlobalZOrder(65535);
                            ddPlayEffect("effect", "res/haixing/audio/effect/ye.mp3", false);
                            // particleSystem.setAutoRemoveOnFinish(true);
                            particleSystem.duration = 3;
                            GlobalHaixingLayer.addChild(particleSystem, 11000);
                            particleSystem.setRotation(180);
                            particleSystem.x = cc.winSize.width / 2;
                            particleSystem.y = cc.winSize.height / 2;

                            GlobalHaixingLayer.emitter_high.stopEmit();
                            GlobalHaixingLayer.emitter_low.stopEmit();
                            // self.scheduleOnce(function(){
                            //     ddStopAllAudios();
                            //     GlobalHaixingLayer.releaseRes();
                            //     cc.director.popScene();
                            // },7);
                            GlobalHaixingLayer.addhaixing10delay(4);
                        }
                    }else{
                        var curGrade = parseInt(GlobalHaixingLayer.gridLabel.getString());
                        cc.log("kag--"+curGrade);
                        if(target.getSpriteColor() == Config_Play.haixing.colors[GlobalHaixingGrade]){
                            cc.log("点击正确");
                            // ddStopAllEffects();
                            ddPlayEffect("effect","res/haixing/audio/effect/correct.mp3");
                            self.setVisible(false);
                            self.couldTouch = false;
                            var grad1 = curGrade + 1;
                            GlobalHaixingLayer.gridLabel.setString(grad1);

                            if(parseInt(GlobalHaixingLayer.gridLabel.getString()) == Config_Play.haixing.grade[GlobalHaixingGrade].needClicked){
                                cc.log("完成一个等级了");
                                GlobalHaixingGrade++;
                                if(GlobalHaixingGrade <= 4) {
                                    GlobalHaixingLayer.staticPic.setTexture("res/haixing/texture/"+Config_Play.haixing.colors[GlobalHaixingGrade]+".png");
                                    ddPlayEffect("effect", "res/haixing/audio/effect/" + Config_Play.haixing.colors[GlobalHaixingGrade] + ".mp3", false);
                                    GlobalHaixingLayer.gridLabel.setString("0");
                                    GlobalHaixingLayer.emitter_high.stopEmit();
                                    GlobalHaixingLayer.emitter_low.stopEmit();
                                    GlobalHaixingLayer.changeEmitter(GlobalHaixingGrade);

                                }else{
                                    GlobalHaixingLayer.gridLabel.setString("");
                                    cc.log("五个等级全完成了，退回到大地图2");
                                    GlobalHaixingLayer.staticPic.setVisible(false);

                                    var size = cc.winSize;
                                    var particleSystem = new cc.ParticleSystem("res/haixing/texture/demo6.plist");
                                    particleSystem.setGlobalZOrder(65535);
                                    ddPlayEffect("effect", "res/haixing/audio/effect/ye.mp3", false);
                                    // particleSystem.setAutoRemoveOnFinish(true);
                                    particleSystem.duration = 3;
                                    GlobalHaixingLayer.addChild(particleSystem, 11000);
                                    particleSystem.setRotation(180);
                                    particleSystem.x = cc.winSize.width / 2;
                                    particleSystem.y = cc.winSize.height / 2;

                                    GlobalHaixingLayer.emitter_high.stopEmit();
                                    GlobalHaixingLayer.emitter_low.stopEmit();
                                    // self.scheduleOnce(function(){
                                    //     ddStopAllAudios();
                                    //     GlobalHaixingLayer.releaseRes();
                                    //     cc.director.popScene();
                                    // },7);
                                    // self.scheduleOnce(function(){
                                    GlobalHaixingLayer.addhaixing10delay(4);
                                }
                            }

                        }else{
                            //if()
                            var grad2 = curGrade - 1;
                            if(grad2 < 0){
                                grad2 = 0;
                            }
                            GlobalHaixingLayer.gridLabel.setString(grad2);
                            // ddStopAllEffects();
                            ddPlayEffect("effect","res/haixing/audio/effect/error.mp3");
                            self.setSpriteColor(self.getAnotherColor(target.getSpriteColor()));
                            cc.log("点击错误");
                        }
                    }
                    cc.log("sprite color is " + target.getSpriteColor() + " and the speed is " + target.getSpriteSpeed());
                    self.showClickedAnim();
                    self.reshuffleAnimation();
                }
            }
        });
        cc.eventManager.addListener(this.sprite_listener,this);
    },
    getAnotherColor:function(color){
        //从1到length选出除了except的数字
        //randomchoose1 = function(length,except){//3,1
        var colornum = 1;
        switch(color){
            case "hong":
                colornum = 1;
                break;
            case "huang":
                colornum = 2;
                break;
            case "lan":
                colornum = 3;
                break;
            case "lv":
                colornum = 4;
                break;
            case "zi":
                colornum = 5;
                break;
            default:
                break;
        }
        var idx = randomchoose1(5,colornum) - 1;
        return Config_Play.haixing.colors[idx];
    }
});