var HaixingSprite = HaixingBase.extend({
    ctor:function(speed,color){//5,hong/huang/lan/lv/zi
        this._super("#haixing"+color+"1.png");
        this.setScale(0.8);
        this.initData(parseFloat(speed),color);
        this.startRun();
    },
    showClickedAnim:function(){
        var self = this;
        this.haixingpo.setVisible(true);
        this.haixingpo.runAction(cc.sequence(newAnimationCreate(4,"haixingpo",0.01,1,false),cc.callFunc(function(){
            self.haixingpo.setVisible(false);
        })));
    },
    getSpriteColor:function(){
        return this.spritecolor;
    },
    getSpriteSpeed:function(){
        return this.speednum;
    },
    setSpriteColor:function(color){
        this.spritecolor = color;
    },
    setSpriteSpeed:function(speed){
        this.speednum = speed;
    },
    startRun:function(){
        var self = this;
        this.runAction(newAnimationCreate(Config_Play.haixing.each_num,"haixing"+this.spritecolor,0.05,600,false));
        this.scheduleUpdate();
    },
    update:function(){
        this.x += this.speednum;
        if(this.x > Config_Play.haixing.emitEndX){
            this.unscheduleUpdate();
            this.setVisible(true);
            this.couldTouch = true;
            this.removeFromParent(true);
//            cc.pool.putInPool(this);
        }
    },
    setHaixingpoNotVisible:function(){
        this.haixingpo.setVisible(false);
    },
    initData:function(speed,color){
        this.speednum = speed;
        this.spritecolor = color;

        this.haixingpo = new cc.Sprite("#haixingpo1.png");
        this.haixingpo.setVisible(false);
        this.haixingpo.setAnchorPoint(0,0);
        this.addChild(this.haixingpo);
    },
    unuse:function(){
        // cc.log("回收到缓冲区");
        this.setHaixingpoNotVisible();
        this.retain();
        this.removeFromParent();
    },
    reuse:function(speed,color){
        // cc.log("从缓冲区取出");
        this.initData(parseFloat(speed),color);
        this.setHaixingpoNotVisible();
        this.startRun();
    },
    reshuffleAnimation:function(){
        this.stopAllActions();
        var self = this;
        this.runAction(newAnimationCreate(Config_Play.haixing.each_num,"haixing"+this.spritecolor,0.05,600,false));
        this.scheduleUpdate();
    }
});
HaixingSprite.reCreate = function(speed,color){
//    if(cc.pool.hasObject(HaixingSprite)){
//        // cc.log("取出 海星,颜色为"+color+",速度为"+speed);
//        return cc.pool.getFromPool(HaixingSprite,parseFloat(speed),color);
//    }else{
        // cc.log("创建 海星,颜色为"+color+",速度为"+speed);
        return new HaixingSprite(parseFloat(speed),color);
//    }
}

/*
 cc.pool.putInPool(obj);             //将对象放入缓冲池
 cc.pool.hasObject(objClass);        //判断缓冲池是否存在可用的指定对象
 cc.pool.removeObject(obj);          //删除指定对象
 cc.pool.getFromPool(objClass);      //从缓冲池获取指定对象
 cc.posol.drainAllPools();            //清空缓冲池
 */
HaixingSprite.reCreateRand = function(speed,flag){
    var randnum;

    var rand100 = getRand1ToN(100);
    if(rand100 < 40){
        randnum = flag;
    }else{
        randnum = getRand0ToN(Config_Play.haixing.kinds-1);//4
    }
    return HaixingSprite.reCreate(parseFloat(speed),Config_Play.haixing.colors[randnum]);
}