var enter_time = 0;
var GlobalADIndex = 0;
var HomeLayer = cc.Layer.extend({
    sprite_monkey:null,
    sprite_play:null,
    sprite_book:null,
    sprite_kapai:null,
    sprite_title:null,
    listener_book:null,
    ani_monkey_1:null,
    ani_monkey_2:null,
    ani_monkey_3:null,
    ad_view:null,
    star_ad:null,
    layer_quit:null,
    label_debug:null,
    parent_check:null,
    ctor:function () {
        cc.log("homelayer enter");
        this._super();
        this.loadRes();
        this.parent_check = null;
        var size = cc.winSize;

        this.createComponents();
        this.addBackKeyListener();
        this.showBeginAnimation();

//        this.scheduleOnce(function(){
        if(!isPad())
            this.getAdConfig();
//        }.bind(this),2);

        return true;
    },
    getAdConfig:function(){
    		this.getAdList(function(){
    		    cc.log("kag AD_ENABLE = " + AD_ENABLE);
    			if(AD_ENABLE){
    				this.ad_view = new AdViewLayer(ARRY_AD_HOME, cc.size(140, cc.winSize.height));
    				this.addChild(this.ad_view, 350);
    			}
    		}.bind(this));
    },
    getAdList:function(showAd){
            if(!recommandEnable()){
                AD_ENABLE = false;
                return;
            }
    		getAdConfig("http://bb.ergeduoduo.com/baby/game.php?act=sharelist&rid=10007&ver=1707" + "&isar=" + (cc.sys.os == cc.sys.OS_ANDROID ? 1 : 0), function(){
    			var ad_value = cc.sys.localStorage.getItem("KEY_AD_LIST");
    			if(ad_value){
    				var parse_result = JSON.parse(ad_value);
    				AD_ENABLE = parse_result.enable;
    				var ad_list = parse_result.list;
    				var ad_in_list = parse_result.inads;
    				var ad_quit_list = parse_result.quitads;
    				if(null != ad_list){
    					var AD_HOME_LIST = new Array(ad_list.length);
                        parseAdList(AD_HOME_LIST, ad_list);
                        ARRY_AD_HOME = filterAdInstall(AD_HOME_LIST, 4);
    				}

                    if(null != ad_in_list){
                    	var AD_IN_LIST = new Array(ad_in_list.length);
                        parseAdList(AD_IN_LIST, ad_in_list);
                        ARRY_AD_IN = filterAdInstall(AD_IN_LIST, 4);
                    }

                    if(null != ad_quit_list){
                        var AD_QUIT_LIST = new Array(ad_quit_list.length);
                        parseAdList(AD_QUIT_LIST, ad_quit_list);
                        ARRY_AD_QUIT = filterAdInstall(AD_QUIT_LIST, 4);
                    }


    				showAd();
    			}
    		});
    },
    loadRes:function(){
        cc.textureCache.addImageAsync("res/home/monkeyswim.pvr.ccz", function() {
            cc.spriteFrameCache.addSpriteFrames("res/home/monkeyswim.plist");
            this.scheduleOnce(function(){
                cc.log("show youyonganimation");
                this.showMonkeySwimming();
            }.bind(this),1);
        }.bind(this));
    },
    leaveGame:function(){
        this.unscheduleAllCallbacks();
        releaseObj(this.listener_play);
        releaseObj(this.listener_book);

        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
    },
    addBackKeyListener:function(){
            var self = this;
    		cc.eventManager.addListener({
    			event: cc.EventListener.KEYBOARD,
    			onKeyReleased: function(keyCode, event) {
    				if (keyCode == cc.KEY.back) {
    					if (self.layer_quit) {
    						self.layer_quit.removeFromParent(true);
    						self.layer_quit = null;
    					} else {
    						var ad_item = getQuitAd();
    //                        var ad_item = ARRY_AD_HOME[1];
    						if(ad_item){
    						    self.layer_quit = new QuitAdViewLayer(function(action) {
                                    switch (action) {
                   						case "quit":
                                		{
                                            ddStopAllEffect();
                                            self.leaveGame();
                                			quiteGame();
                                			break;
                                		}
                                		case "continue":
                                		{
                                		    self.layer_quit.removeFromParent(true);
                                			self.layer_quit = null;
                                			break;
                                		}
                                		default:
                                		    break;
                                	}
                               	}, ad_item);
    						}else{
    						    self.layer_quit = new QuitViewLayer(function(action) {
                                	switch (action) {
                                	    case "quit":
                                	    {
                                            ddStopAllEffect();
                                            self.leaveGame();
                                		    quiteGame();
                                	        break;
                                	    }
                                	    case "continue":
                                	    {
                                	        self.layer_quit.removeFromParent(true);
                                		    self.layer_quit = null;
                                		    break;
                                	    }
                                	    default:
                                	        break;
                                    }
                                });
    						}
    						self.addChild(self.layer_quit, 250);
    					}
    				}
    				else if (keyCode == cc.KEY.menu) {

    				}
    			}}, this);
    },
    createComponents:function(){
        this.background = createStaticNode("res/home/background.png",this,cc.p(cc.winSize.width/2,cc.winSize.height/2),0);
        resetScale(this.background);
        this.monkey = createStaticNode("res/home/left.png",this,cc.p(cc.winSize.width + 30,-30),0);

        this.sprite_title = new cc.Sprite("res/home/home_title.png");
        this.sprite_title.x = Config_Home.title_begin.x;
        this.sprite_title.y = Config_Home.title_begin.y;
        this.sprite_title._setAnchorX(0.5);
        this.sprite_title._setAnchorY(0.1);
        this.sprite_title.setScale(0.95, 1.1);
        this.addChild(this.sprite_title);

        this.sprite_play = new MenuSingleSprite("res/home/home_play.png");
        this.sprite_play.x = Config_Home.menu01_begin.x;
        this.sprite_play.y = Config_Home.menu01_begin.y;
        this.addChild(this.sprite_play);

        this.sprite_book = new MenuSingleSprite("res/home/home_baike.png");
        this.sprite_book.x = Config_Home.menu02_begin.x;
        this.sprite_book.y = Config_Home.menu02_begin.y;
        this.addChild(this.sprite_book);

        this.sprite_kapai = new MenuSingleSprite("res/home/home_kapai.png");
        this.sprite_kapai.x = Config_Home.menu03_begin.x;
        this.sprite_kapai.y = Config_Home.menu03_begin.y;
        this.addChild(this.sprite_kapai);

        if(!isPad())
            this.addFeedbackMenu();
    },
    addFeedbackMenu:function(){
        var self = this;
        var feedbackItem = new cc.MenuItemImage(
            "res/feedback/feedback.png",
            "res/feedback/feedback.png",
            function () {
                if (!self.parent_check) {
                    self.parent_check = new ParentCheckLayer(
                        function() {
                            cc.log("answer wrong!!!");
                            if (self.parent_check) {
                                self.parent_check.removeFromParent(true);
                                self.parent_check = null;
                            }
                        },
                        function() {
                            cc.log("answer right!!!");
                            self.parent_check.removeFromParent(true);
                            self.parent_check = null;
                            showFeedback();
                        }
                    );
                    self.addChild(self.parent_check, 250);
                 }
            }, this);
        feedbackItem.attr({
            x: cc.winSize.width  - 100,
            y: cc.winSize.height - 100,
            anchorX: 0.5,
            anchorY: 0.5
        });
        var menu = new cc.Menu(feedbackItem);
        menu.x = 0;
        menu.y = 0;
        this.addChild(menu,65535);
    },
    showBeginAnimation:function(){
        var move_duration = 0.21;
        var animation = cc.sequence(
            cc.moveTo(0.2, Config_Home.title_end).easing(cc.easeInOut(3)),
            cc.scaleBy(move_duration / 4, 1.15, 0.85), cc.scaleTo(move_duration / 4, 1, 1),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 15)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -15)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 10)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -10)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 5)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -5)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3))
        );
        this.sprite_title.runAction(cc.sequence(
            cc.moveTo(0.2, Config_Home.title_end).easing(cc.easeInOut(3)),
            cc.scaleBy(move_duration / 4, 1.15, 0.85),
            cc.scaleTo(move_duration / 4, 1, 1),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 15)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -15)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 10)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -10)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 5)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -5)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3))
        ));

        this.sprite_play.runAction(cc.sequence(
            cc.delayTime(0.4),
            cc.moveTo(0.3, Config_Home.menu01_end).easing(cc.easeInOut(3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 9)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -9)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 6)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -6)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.callFunc(function() {
                this.sprite_play.runAction(cc.repeatForever(cc.sequence(cc.scaleTo(0.8, 1.05, 1.05), cc.scaleTo(0.8, 0.95, 0.95))));
            }.bind(this))
        ));

        this.sprite_book.runAction(cc.sequence(
            cc.delayTime(0.8),
            cc.moveTo(0.4, Config_Home.menu02_end).easing(cc.easeInOut(3)),
            cc.callFunc(function() {
                this.addListener();
            }.bind(this)),
            cc.moveBy(move_duration, cc.p(0, 9)),
            cc.moveBy(move_duration, cc.p(0, -9)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 6)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -6)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.callFunc(function() {
                this.sprite_book.runAction(cc.repeatForever(cc.sequence(cc.scaleTo(0.8, 1.05, 1.05), cc.scaleTo(0.8, 0.95, 0.95))));
            }.bind(this))
        ));

        this.sprite_kapai.runAction(cc.sequence(
                    cc.delayTime(0.6),
                    cc.moveTo(0.4, Config_Home.menu03_end).easing(cc.easeInOut(3)),
                    cc.callFunc(function() {
                        this.addListener();
                    }.bind(this)),
                    cc.moveBy(move_duration, cc.p(0, 9)),
                    cc.moveBy(move_duration, cc.p(0, -9)),
                    cc.moveBy(move_duration * 2 / 3, cc.p(0, 6)),
                    cc.moveBy(move_duration * 2 / 3, cc.p(0, -6)),
                    cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
                    cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
                    cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
                    cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
                    cc.callFunc(function() {
                        this.sprite_kapai.runAction(cc.repeatForever(cc.sequence(cc.scaleTo(0.8, 1.05, 1.05), cc.scaleTo(0.8, 0.95, 0.95))));
                    }.bind(this))
                ));

    },
    addListener:function(){
        var self = this;
        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());

                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode)) {
                    // ddPlayEffect("effect", soundPath(null, "click", null), false);
                    if (target == self.sprite_kapai) {
                        cc.log("kapai is selected!!!");
                        if (!self.sprite_kapai.isEnable()) {
                            return false;
                        }
                        self.sprite_kapai.setEnable(false);
                        ddPlayEffect("effect","res/home/audio/effect/click.mp3",false);
                        self.scheduleOnce(function() {
                            self.monkey.stopAllActions();
                            self.sprite_book.stopAllActions();
                            self.sprite_kapai.stopAllActions();
                            self.sprite_play.stopAllActions();
                            self.sprite_title.stopAllActions();

                            cc.textureCache.removeAllTextures();
                            cc.spriteFrameCache.removeSpriteFrames();

                            ddStopAllAudios();
                            cc.director.runScene(new KapaiScene());
                            // pushDragonScene(dragon_array[dragon_play_index]);
                        }, 0);
                    }else if (target == self.sprite_book) {

                        ddPlayEffect("effect","res/home/audio/effect/click.mp3",false);
                        cc.log("book is selected!!!");
                        if (!self.sprite_book.isEnable()) {
                            return false;
                        }

                        playVideo();
                        // ddStopAllAudios();
                        //self.sprite_book.setEnable(false);
                        // cc.director.pushScene(new KapaiScene());
                    } else if(target == self.sprite_play){
                        cc.log("play is selected!!!");
                        if (!self.sprite_play.isEnable()) {
                            return false;
                        }
                        self.sprite_play.setEnable(false);
                        ddPlayEffect("effect","res/home/audio/effect/click.mp3",false);
                        self.scheduleOnce(function() {
                            self.monkey.stopAllActions();
                            self.sprite_book.stopAllActions();
                            self.sprite_kapai.stopAllActions();
                            self.sprite_play.stopAllActions();
                            self.sprite_title.stopAllActions();

                            cc.textureCache.removeAllTextures();
                            cc.spriteFrameCache.removeSpriteFrames();

                            ddStopAllAudios();
                            cc.director.runScene(new DadituScene());
                            // pushDragonScene(dragon_array[dragon_play_index]);
                        }, 0);

                    }
                    return false;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {

            }
        });

        this.listener_play = sprite_listener.clone();
        this.listener_play.retain();
        this.listener_book = sprite_listener.clone();
        this.listener_book.retain();
        this.listener_kapai = sprite_listener.clone();
        this.listener_kapai.retain();

        cc.eventManager.addListener(this.listener_play, this.sprite_play);
        cc.eventManager.addListener(this.listener_book, this.sprite_book);
        cc.eventManager.addListener(this.listener_kapai, this.sprite_kapai);
    },
    onEnterTransitionDidFinish:function(){
        this.sprite_book.setEnable(true);
        this.sprite_kapai.setEnable(true);
        this.sprite_play.setEnable(true);
        // ddPlayEffect("music", soundPath(null, "home", "back"), true);
    },
    onExitTransitionDidStart:function(){
        cc.audioEngine.stopMusic(false);
    },
    showMonkeySwimming:function(){
        var tmp = -170;
        if(isPad()){
            tmp = -120;
        }
        this.monkey.runAction(cc.sequence(
            cc.spawn(newAnimationCreate(20,"youyong",0.05,1,false),cc.moveBy(1.1,tmp,200).easing(cc.easeIn(1))),
            cc.callFunc(function(){
                cc.audioEngine.setMusicVolume(1);
                cc.audioEngine.setEffectsVolume(1);
                if(enter_time == 0){
                    ddPlayEffect("effect","res/home/audio/effect/duoduo1.mp3",false);
                }else{
                    ddPlayEffect("effect","res/home/audio/effect/duoduo2.mp3",false);
                }
                enter_time ++;
                this.monkey.runAction(cc.repeatForever(newAnimationCreate(20,"youyong",0.05,1,false)))
            }.bind(this))
        ));
    },
});

var HomeScene = cc.Scene.extend({
    ctor:function(){
        this._super();
        ddStopAllAudios();
        cc.audioEngine.setMusicVolume(1);
        cc.audioEngine.setEffectsVolume(1);
        ddPlayEffect("music","res/home/audio/music/background.mp3",true);
        var layer = new HomeLayer();
        this.addChild(layer);
    },
    onEnter:function () {
        this._super();
    }
});

