var QiQiuSprite = cc.Sprite.extend({
    ctor:function(speed,particleindex){//5,hong/huang/lan/lv/zi
        this._super("res/jianyu/texture/qiqiu1.png");
        this.setScale(0.8);
        this.initData(parseFloat(speed),particleindex);
        this.startRun();
    },
    showClickedAnim:function(){
        var self = this;
        this.qiqiupo.setVisible(true);
        //animationCreate(number,prefix,start,delayPerUnit,times,resumeOriginFrame)
        this.qiqiupo.runAction(cc.sequence(animationCreate(4,"res/jianyu/texture/qiqiubao",1,0.01,1,false),cc.callFunc(function(){
            self.qiqiupo.setVisible(false);
        })));
    },
    getSpriteSpeed:function(){
        return this.speednum;
    },
    setSpriteSpeed:function(speed){
        this.speednum = speed;
    },
    startRun:function(){
        var self = this;
        //newAnimationCreate(number,prefix,delayPerUnit,times,resumeOriginFrame)
        this.runAction(cc.repeatForever(animationCreate(8,"res/jianyu/texture/qiqiu",1,0.1,1,false)));
        this.scheduleUpdate();
    },
    update:function(){
        //cc.log("qiqiu update");
        this.x -= this.speednum*5;
        if(this.x < Config_Play.jianyu.qiuqiuEmitEndX){
            this.unscheduleUpdate();
            this.setVisible(true);
            cc.pool.putInPool(this);
        }

        var largeX = cc.rect(this.x + this.qiqiupengzhuang.x,this.y + this.qiqiupengzhuang.y,90,90);
        var smallX = cc.rect(GlobalJianyuLayer.jianyu.x+GlobalJianyuLayer.jianyupengzhuang.x + 80,GlobalJianyuLayer.jianyu.y +GlobalJianyuLayer.jianyupengzhuang.y + 210,30,15);

        if(cc.rectIntersectsRect(largeX, smallX)){
            //cc.log("发生碰撞啦******************************************************");
            //this.setVisible(false);
            ddPlayEffect("effect","res/jianyu/audio/effect/qiqiuboom.mp3",false);


            var particleSystem = new cc.ParticleSystem("res/jianyu/plists/"+getRand1ToN(11)+".plist");
            //var particleSystem = new cc.ParticleSystem("res/jianyu/plists/1.plist");
            particleSystem.setAutoRemoveOnFinish(true);
            this.addChild(particleSystem, 1000);
            particleSystem.duration = 0.1;
            // particleSystem.x = size.width / 2;
            // particleSystem.y = size.height / 2;

            this.unscheduleUpdate();
            this.showClickedAnim();
            this.scheduleOnce(function(){
                cc.pool.putInPool(this);
            },0.01);
        }
    },
    setQiqiupoNotVisible:function(){
        this.qiqiupo.setVisible(false);
    },
    initData:function(speed,particleindex){
        this.speednum = speed;
        this.particleindex = particleindex;

        this.qiqiupo = new cc.Sprite("res/jianyu/texture/qiqiubao3.png");
        this.qiqiupo.setPosition(-36,0);
        this.qiqiupo.setVisible(false);
        this.qiqiupo.setAnchorPoint(0,0);
        this.addChild(this.qiqiupo);

        this.qiqiupengzhuang = new cc.Sprite("res/200x200.png",cc.rect(0,0,90,90));
        // this.qiqiupengzhuang.setPosition(64,260);//
        this.qiqiupengzhuang.setPosition(64,260);
        this.qiqiupengzhuang.setVisible(false);
        this.addChild(this.qiqiupengzhuang);
    },
    unuse:function(){
        // cc.log("回收到缓冲区");
        this.setQiqiupoNotVisible();
        this.retain();
        this.removeFromParent();
    },
    reuse:function(speed){
        // cc.log("从缓冲区取出");
        this.initData(parseFloat(speed));
        this.setQiqiupoNotVisible();
        this.startRun();
    },
    reshuffleAnimation:function(){
        this.stopAllActions();
        var self = this;
        this.runAction(cc.sequence(animationCreate(8,"res/jianyu/texture/qiqiu",1,0.01,1,false)));
        this.scheduleUpdate();
    }
});
QiQiuSprite.reCreate = function(speed){
    if(cc.pool.hasObject(QiQiuSprite)){
        //cc.log("取出 气球,速度为"+speed);
        return cc.pool.getFromPool(QiQiuSprite,parseFloat(speed));
    }else{
        //cc.log("创建 气球,速度为"+speed);
        return new QiQiuSprite(parseFloat(speed));
    }
}

/*
 cc.pool.putInPool(obj);             //将对象放入缓冲池
 cc.pool.hasObject(objClass);        //判断缓冲池是否存在可用的指定对象
 cc.pool.removeObject(obj);          //删除指定对象
 cc.pool.getFromPool(objClass);      //从缓冲池获取指定对象
 cc.pool.drainAllPools();            //清空缓冲池
 */
QiQiuSprite.reCreateRand = function(speed){
    return QiQiuSprite.reCreate(parseFloat(speed));
}
