var GlobalJingyuLayer = null;
var JingyuLayer = SmallLayer.extend({
    star_ad:null,
    jingyuCouldTouch:null,
    couldTime:null,
    runOnce:null,
    passSeconds:null,
    couldGiftTime:null,
    giftTotalTime:null,
    ctor:function(){
        cc.audioEngine.setMusicVolume(1);
        cc.audioEngine.setEffectsVolume(1);

        GlobalADIndex++;
        GlobalJingyuLayer = this;
        this.star_ad = null;
        this._super();
        this.preCreateAnimation();
        this.passSeconds = 0;
        this.couldTime = false;
        this.runOnce = true;
        this.jingyuCouldTouch = false;
        this.couldGiftTime = false;
        this.giftTotalTime = 0;
        this.addComponents();
        popSceneMenu(this);
    },
    loadRes:function(){
        // cc.log("loadRes-jingyu");
    },
    addDynamic:function(){
        // cc.log("addDynamic-jingyu");
        this.shang = newCircleRun(this,"res/jingyu/texture/jing_shui_shang.png",1278*0.2,1278,640,280,0,1);//1278*570
        // this.shang[0].stop();
        // this.shang[1].stop();
        this.zhong = newCircleRun(this,"res/jingyu/texture/jing_shui_zhong.png",1278*0.2,1278,-781,280,1,-1);//1278*570
        //this.zhong[0]和this.zhong[1]来变色
        this.xia = newCircleRun1(this,"res/jingyu/texture/jing_shui_xia.png",1278*0.2,1278,640,280,2000,1);//1278*570
//        this.xia[0].setGlobalZOrder(1);
//        this.xia[1].setGlobalZOrder(1);
    },
    recvEvents:function(){
    },
    addpenshuixiaoyu:function(){
        this.penshuixiaoyu = [];
        this.penshuixiaoyu[0] = createStaticNode_Reverse("res/jingyu/texture/xiaofenyu-" + 1 + "-1.png", this, cc.p(GW2 - 255, GH2 - 10), 10);
        this.penshuixiaoyu[1] = createStaticNode("res/jingyu/texture/xiaofenyu-" + 2 + "-1.png", this, cc.p(GW2 + 125, GH2 - 10), 10);
        this.penshuixiaoyu[2] = createStaticNode("res/jingyu/texture/xiaofenyu-" + 3 + "-1.png", this, cc.p(GW2 + 125, GH2 - 10), 10);
        for(var i = 0;i < 3;i ++){
            this.penshuixiaoyu[i].setVisible(false);
            this.penshuixiaoyu[i].setGlobalZOrder(-2);
        }
    },
    addStatic: function () {
        // cc.log("addStatic-jingyu");
        this.bac = createStaticNode("res/jingyu/texture/jing-beijing.png",this,cc.p(cc.winSize.width/2,cc.winSize.height/2),0);
        resetScale(this.bac);
        this.bac.setGlobalZOrder(-4);
    },
    startPassTimer:function(){
        this.schedule(function(){
            // cc.log("每秒一次");
            if(this.couldTime)
                this.passSeconds ++;
        }.bind(this),1,cc.REPEAT_FOREVER,0);
    },
    releaseAnimation:function(){
        if(this.penshuixiaoyu0)
            this.penshuixiaoyu0.release();
        if(this.penshuixiaoyu1)
            this.penshuixiaoyu1.release();
        if(this.penshuixiaoyu2)
            this.penshuixiaoyu2.release();
        if(this.shuihua1)
            this.shuihua1.release();
        if(this.shuihua2)
            this.shuihua2.release();
        if(this.shuihua3)
            this.shuihua3.release();

        if(this.jingyupenshui1)
            this.jingyupenshui1.release();
        if(this.jingyukualways)
            this.jingyukualways.release();

        if(this.penshuialways){
            this.penshuialways.release();
        }
    },
    preCreateAnimation:function(){
        this.penshuixiaoyu0 = animationCreate(5, "res/jingyu/texture/xiaofenyu-" + 1 + "-", 1, 0.11, 1, false);
        this.penshuixiaoyu1 = animationCreate(5, "res/jingyu/texture/xiaofenyu-" + 2 + "-", 1, 0.11, 1, false);
        this.penshuixiaoyu2 = animationCreate(5, "res/jingyu/texture/xiaofenyu-" + 3 + "-", 1, 0.11, 1, false);

        this.penshuixiaoyu0.retain();
        this.penshuixiaoyu1.retain();
        this.penshuixiaoyu2.retain();


        this.shuihua1 = animationCreate(5,"res/jingyu/texture/shuihua-kaishi-",1,0.1,1,false);
        this.shuihua2 = animationCreate(5,"res/jingyu/texture/shuihua-chixu-",1,0.1,2,false);
        this.shuihua3 = animationCreate(5,"res/jingyu/texture/shuihua-jiesu-",1,0.05,1,false);

        this.shuihua1.retain();
        this.shuihua2.retain();
        this.shuihua3.retain();

        this.jingyupenshui1 = animationCreate(13,"res/jingyu/texture/jing-penshui-",1,0.13,1,false);
        this.jingyupenshui1.retain();

        this.jingyukualways = animationCreate(13,"res/jingyu/texture/jing-ku-",1,0.1,65535,false);
        this.jingyukualways.retain();

        this.penshuialways = animationCreate(13,"res/jingyu/texture/jing-penshui-",1,0.13,65535,false);
        this.penshuialways.retain();
    },
    jingyupenshui:function(){
        var self = this;
        if(!self.giftlayer){
            self.giftlayer = new GiftLayer(self.space);
            self.giftlayer.setGlobalZOrder(55535);
            self.addChild(self.giftlayer);
        }
        this.jingyu.stopAllActions();
        this.jingyu.runAction(cc.sequence(
            cc.callFunc(function(){
                this.shuihua.setVisible(true);
                this.jingyuCouldTouch = false;

                this.giftlayer.startEmit(1);
                this.scheduleOnce(function(){
                    this.giftlayer.stopEmit();
                }.bind(this),1.3);

                this.shuihua.setScale(1);
                this.shuihua.runAction(cc.sequence(
                    this.shuihua1,
                    this.shuihua2,
                    this.shuihua3,
                    cc.callFunc(function(){
                        this.shuihua.setVisible(false);
                    }.bind(this))
                ));
                this.scheduleOnce(function(){
                    this.penshuixiaoyu[0].setVisible(true);
                    this.penshuixiaoyu[0].runAction(cc.sequence(this.penshuixiaoyu0,cc.callFunc(function(){
                        this.penshuixiaoyu[0].setVisible(false);
                    }.bind(this))));
                }.bind(this),0.5);

                this.scheduleOnce(function(){
                    this.penshuixiaoyu[1].setVisible(true);
                    this.penshuixiaoyu[1].runAction(cc.sequence(this.penshuixiaoyu1,cc.callFunc(function(){
                        this.penshuixiaoyu[1].setVisible(false);
                    }.bind(this))));
                }.bind(this),0.2);

                this.scheduleOnce(function(){
                    this.penshuixiaoyu[2].setVisible(true);
                    this.penshuixiaoyu[2].runAction(cc.sequence(this.penshuixiaoyu2,cc.callFunc(function(){
                        this.penshuixiaoyu[2].setVisible(false);
                    }.bind(this))));
                }.bind(this),0);

            }.bind(this)),//先将事件监听器屏蔽
            this.jingyupenshui1,
            cc.spawn(
                // animationCreate(13,"res/jingyu/texture/jing-penshui-",1,0.1,1,false),
                this.jingyukualways,
                cc.callFunc(function(){
                    this.scheduleOnce(function(){
                        this.jingyuCouldTouch = true;
                        this.runOnce = true;
                        this.couldTime = true;
                        // //删除pengshuixiaoyu
                        // if(this.penshuixiaoyu[0]) {
                        //     this.penshuixiaoyu[0].removeFromParent(true);
                        //     this.penshuixiaoyu[0] = null;
                        // }
                        // if(this.penshuixiaoyu[1]) {
                        //     this.penshuixiaoyu[1].removeFromParent(true);
                        //     this.penshuixiaoyu[1] = null;
                        // }
                        // if(this.penshuixiaoyu[2]) {
                        //     this.penshuixiaoyu[2].removeFromParent(true);
                        //     this.penshuixiaoyu[2] = null;
                        // }
                    }.bind(this),0.3);
                }.bind(this))
            )
        ));
    },
    addShuihua:function(){
        this.shuihua = createStaticNode("res/jingyu/texture/shuihua-kaishi-1.png",this,cc.p(GW2 - 60, GH2 + 129),8);
        this.shuihua.setVisible(false);
        this.shuihua.setGlobalZOrder(-2);
    },
    shuihuaStartOrStopChixu:function(isStart){
        if(isStart) {
            this.shuihua.setVisible(true);
            this.shuihua.stopAllActions();
            //animationCreate(5,"res/jingyu/texture/shuihua-kaishi-",1,0.1,1,false)
            this.shuihua.runAction(cc.sequence(animationCreate(5,"res/jingyu/texture/shuihua-kaishi-",1,0.1,1,false),animationCreate(5, "res/jingyu/texture/shuihua-chixu-", 1, 0.1, 65535, false)));//-1改成65535
        }else{
            this.shuihua.setVisible(true);
            this.shuihua.stopAllActions();
            this.shuihua.runAction(cc.sequence(
                animationCreate(5,"res/jingyu/texture/shuihua-jiesu-",1,0.05,1,false),
                cc.callFunc(function(){
                    this.shuihua.setVisible(false);
            }.bind(this))));
        }
    },
    runOnceTime:function(isRunOnce){
        var self = this;
        if(isRunOnce){
            this.runOnce = false;
            this.jingyu.stopAllActions();
            this.jingyu.runAction(cc.sequence(
                cc.callFunc(function(){
                    this.jingyuCouldTouch = false;
                    this.passSeconds = 0;
                    this.couldTime = false;
                    // this.giftlayer.stopEmit();
                }.bind(this)),
                cc.spawn(
                    animationCreate(7,"res/jingyu/texture/jing-youzou-",1,0.1,1,false),
                    cc.callFunc(function(){
                        self.zhong[0].runAction(cc.tintTo(1,0,0,90));
                        self.zhong[1].runAction(cc.tintTo(1,0,0,90));
                    }.bind(self))
                ),
                cc.callFunc(function(){
                    this.jingyu.setPosition(cc.p(cc.winSize.width + 300,cc.winSize.height/2));
                }.bind(this)),
                cc.delayTime(2),
                cc.spawn(
                    animationCreate(13,"res/jingyu/texture/jing-moren-",1,0.1,1,false),
                    cc.bezierTo(1.3,[cc.p(GW+300,GH2),cc.p(GW2,GH2-150),cc.p(GW2+10,GH2-80)]),
                    cc.callFunc(function(){
                        self.zhong[0].runAction(cc.tintTo(1.3,255,255,255));
                        self.zhong[1].runAction(cc.tintTo(1.3,255,255,255));
                    }.bind(this))
                ),
                cc.callFunc(function(){
                    if(!self.giftlayer){
                        self.giftlayer = new GiftLayer(self.space);
                        self.giftlayer.setGlobalZOrder(55535);
                        self.addChild(self.giftlayer);
                    }
                    this.jingyupenshui();
                }.bind(this))
            ));
        }else{

        }
    },
    update:function(dt){
        var timeStep = 0.04;
        this.space.step(timeStep);

        // cc.log("passSeconds : " + this.passSeconds);
        if(this.passSeconds >= 10){
            cc.log("当前时间大于10秒,应该退出屏幕，重新出场");
            this.passSeconds = 0;
            this.couldTime = false;
            this.jingyuCouldTouch = false;
            this.runOnceTime(this.runOnce);
        }

        if(this.couldGiftTime){//在此
            this.giftTotalTime += 1;
            if(this.giftTotalTime == parseInt(60 * 5)){
                // cc.log("按下了五秒");
                this.giftlayer.startEmit(2);
                this.shuihua.stopAllActions();
                this.shuihua.setScale(1.1);
                this.shuihua.runAction(animationCreate(5, "res/jingyu/texture/shuihua-chixu-", 1, 0.08, -1, false));
                this.playParticles(2);
            }else if(this.giftTotalTime == parseInt(60 * 10)){
                // cc.log("按下了十秒");
                this.giftlayer.startEmit(3);
                this.shuihua.stopAllActions();
                this.shuihua.setScale(1.2);
                this.shuihua.runAction(animationCreate(5, "res/jingyu/texture/shuihua-chixu-", 1, 0.07, -1, false));
                this.playParticles(3);
            }else if(this.giftTotalTime == parseInt(60 * 15)){
                // cc.log("按下了十五秒");
                this.giftlayer.startEmit(4);
                this.shuihua.stopAllActions();
                this.shuihua.setScale(1.3);
                this.shuihua.runAction(animationCreate(5, "res/jingyu/texture/shuihua-chixu-", 1, 0.06, -1, false));
                this.playParticles(4);
            }else if(this.giftTotalTime == parseInt(60 * 20)){
                // cc.log("按下了二十秒");
                this.giftlayer.startEmit(5);
                this.shuihua.stopAllActions();
                this.shuihua.setScale(1.4);
                this.shuihua.runAction(animationCreate(5, "res/jingyu/texture/shuihua-chixu-", 1, 0.05, -1, false));
                this.playParticles(5);
                jsb.AudioEngine.play2d("res/jingyu/audio/effect/guzhang.mp3");

//                ddPlayEffect("music","res/jingyu/audio/effect/guzhang.mp3",false);
            }
            else if(this.giftTotalTime == parseInt(60 * 35)){
                    jsb.AudioEngine.play2d("res/jingyu/audio/effect/guzhang.mp3");
//                ddPlayEffect("music","res/jingyu/audio/effect/guzhang.mp3",false);
            }else if(this.giftTotalTime == parseInt(60 * 50)){
                    jsb.AudioEngine.play2d("res/jingyu/audio/effect/guzhang.mp3");
//                ddPlayEffect("music","res/jingyu/audio/effect/guzhang.mp3",false);
            }
        }else{
            this.giftTotalTime = 0;
        }
    },
    playParticles:function(idx){
        var i = idx - 1;
        var size = cc.winSize;
        jsb.AudioEngine.play2d("res/jingyu/audio/effect/yanhua.mp3");
//        ddPlayEffect("effect","res/jingyu/audio/effect/yanhua.mp3",false);
        var particleSystem = new cc.ParticleSystem("res/jingyu/texture/plists/"+i+".plist");
        particleSystem.setAutoRemoveOnFinish(true);
        this.addChild(particleSystem, 11000);
        particleSystem.duration = 1;
        particleSystem.setRotation(180);
        particleSystem.x = size.width / 2;
        particleSystem.y = size.height / 2;
    },
    addComponents:function(){
        if (AD_ENABLE && ARRY_AD_IN && ARRY_AD_IN.length) {
                GlobalADIndex = (GlobalADIndex++)  % ARRY_AD_IN.length;
                this.star_ad = new StarAdLayer(ARRY_AD_IN[GlobalADIndex]);
                this.star_ad.setGlobalZOrder(65535);
                this.star_ad.x = cc.winSize.width - 85;
                this.star_ad.y = - 15;
                this.addChild(this.star_ad, 65535);
        }

        this.addpenshuixiaoyu();

        this.addShuihua();

        // this.giftlayer = new GiftLayer();
        // this.giftlayer.setGlobalZOrder(55535);
        // this.addChild(this.giftlayer);

        var self = this;
        this.jingyu = createStaticNode("res/jingyu/texture/jing-moren-1.png",this,cc.p(cc.winSize.width + 300,cc.winSize.height/2),21.5);
        this.jingyu.setGlobalZOrder(-2);
        this.jingyu.onTouchBegan = function(touch,event){
            var target = event.getCurrentTarget();
            var locationInNode = target.convertToNodeSpace(touch.getLocation());
            var s = target.getContentSize();
            var rect = cc.rect(0, 0, s.width, s.height);
            if (cc.rectContainsPoint(rect, locationInNode) && self.jingyuCouldTouch) {
                self.couldGiftTime = true;
                // cc.log("开始按下");
                self.passSeconds = 0;
                self.couldTime = false;
                if(!self.giftlayer){
                    self.giftlayer = new GiftLayer(self.space);
                    self.giftlayer.setGlobalZOrder(55535);
                    self.addChild(self.giftlayer);
                }

                self.giftlayer.emitters[1].createRandBody();
                self.giftlayer.startEmit(1);
                self.shuihuaStartOrStopChixu(true);
                self.jingyu.stopAllActions();
                self.jingyu.runAction(self.penshuialways);
                return true;
            }else{
                return false;
            }
        };
        this.jingyu.onTouchMoved = function(touch,event){
            self.passSeconds = 0;
        },
        this.jingyu.onTouchEnded = function(touch,event){
            self.couldGiftTime = false;
            // cc.log("按下结束");
            self.passSeconds = 0;
            self.shuihua.setScale(1);
            self.couldTime = true;
            // self.giftlayer.stopEmit();
            //
            self.giftlayer.removeFromParent(true);
            self.giftlayer = null;

            self.shuihuaStartOrStopChixu(false);
            self.jingyu.stopAllActions();
            self.jingyu.runAction(self.jingyukualways);
        };


        this.jingyu.runAction(cc.spawn(
            // animationCreate(number,prefix,start,delayPerUnit,times,resumeOriginFrame)
            // animationCreate(13,"res/jingyu/texture/jing-moren-",1,0.1,-1,false),//这里的-1使得动作repeatForever，然后会报错Action updateoverride me
            cc.sequence(
                cc.spawn(
                    cc.sequence(cc.bezierTo(2,[cc.p(GW+300,GH2),cc.p(GW2,GH2-150),cc.p(GW2+10,GH2-80)]),
                    cc.delayTime(0.3),cc.callFunc(function(){
                            ddPlayEffect("effect","res/jingyu/audio/music/jing.mp3",false);
//                                jsb.AudioEngine.play2d("res/jingyu/audio/music/jing.mp3");
                        }.bind(self))
                    ),
                    cc.callFunc(function(){
                        self.zhong[0].runAction(cc.tintTo(1.3,255,255,255));
                        self.zhong[1].runAction(cc.tintTo(1.3,255,255,255));
                    }.bind(self))
                ),
                animationCreate(13,"res/jingyu/texture/jing-penshui-",1,0.1,2,false)
            ),
            cc.sequence(cc.delayTime(4.5),cc.callFunc(function(){
                // cc.log("鲸鱼话说完了，游到了中心，开始计时");//添加事件监听器
                registerTouchEventOneByOne(self.jingyu,true,self.jingyu);
                self.jingyupenshui();
                self.startPassTimer();
                self.couldTime = true;
                self.passSeconds = 0;
                self.initPhysics();


                self.scheduleUpdate();
            }.bind(self)))
        ));
    },
    initPhysics:function(){
        this.space = new cp.Space();
        // cc.log("创建space................");
        // this.setupDebugNode();

        var winSize = cc.winSize;
        var staticBody = this.space.staticBody;

        // Walls
        var walls = [ new cp.SegmentShape( staticBody, cp.v(0 - 1500,0 - 280), cp.v(winSize.width + 1500,0 - 280), 0 ),               // bottom
//		              new cp.SegmentShape( staticBody, cp.v(0,winSize.height), cp.v(winSize.width,winSize.height), 0),    // top
            new cp.SegmentShape( staticBody, cp.v(0,0), cp.v(0,winSize.height), 0),             // left
            new cp.SegmentShape( staticBody, cp.v(winSize.width,0), cp.v(winSize.width,winSize.height), 0)  // right
        ];
        walls[0].group = 1;
        walls[0].layers = 1;
        walls[0].setCollisionType(10001);
        for( var i=0; i < walls.length; i++ ) {
            var shape = walls[i];
            shape.setElasticity(1);
            shape.setFriction(1);
            this.space.addStaticShape( shape );
        }

        // Gravity
        this.space.gravity = cp.v(0, -450);

        // cc.log("kag initPhysics");
        this.space.addCollisionHandler(10001,10002,this.collisionBegin.bind(this),null,null,null);
    },
    collisionBegin:function(araiber, space){
        // cc.log("kag collision Begin");
        var shapeA = araiber.getShapes()[0];
        var shapeB = araiber.getShapes()[1];

        var bodyA = shapeA.getBody();
        var bodyB = shapeB.getBody();

        var spriteA = bodyA.datas;
        var spriteB = bodyB.datas;

//        if(shapeA.collision_type == 10002){
//            spriteA.removeFromParent(true);
//        }
//        if(shapeB.collision_type == 10002){
//            if(spriteB){
//                spriteB.release();
//                spriteB.removeFromParent(true);
//                spriteB = null;
//            }
//        }
        GlobalJingyuLayer.space.addPostStepCallback(function(){
            try{
                GlobalJingyuLayer.space.removeBody(bodyB);
                GlobalJingyuLayer.space.removeShape(shapeB);
            }
            catch (error){
                cc.log("already be moved !!!")
            }
            if(spriteB){
                 spriteB.release();
                 spriteB.removeFromParent(true);
                 spriteB = null;
            }
        });


        return false;
    },
    unregisterAllEvents:function(){
    },
    releaseRes:function(){
        if(this.shuihua)
            this.shuihua.stopAllActions();
        this.releaseAnimation();
        ddStopAllAudios();
        this.unregisterAllEvents();
        this.cleanScene();
    },
    cleanScene:function(){
        closeStarAd(this.star_ad);
        this.unscheduleAllCallbacks();

        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
    }
});

var JingyuScene = cc.Scene.extend({
     ctor:function () {
            this._super();
            ddStopAllAudios();
            umengEvent("fish_type", "JingYu");

            this.scheduleOnce(function(){
                cc.audioEngine.setMusicVolume(1);
                cc.audioEngine.setEffectsVolume(1);
                ddPlayEffect("music","res/jingyu/audio/music/background.mp3",true);
//                  jsb.AudioEngine.play2d("res/jingyu/audio/music/background.mp3",true);
            },1.3);

            var layer = new JingyuLayer();
            this.addChild(layer);
        },
       onEnter:function(){
            cc.audioEngine.setMusicVolume(1);
            cc.audioEngine.setEffectsVolume(1);
            this._super();
            ddStopAllAudios();
            cc.textureCache.removeAllTextures();
            cc.spriteFrameCache.removeSpriteFrames();
       }
});