var custom_pre_index = 0;
var custom_cur_index = 0;
var custom_resource_length = 0;
var custom_timeout = 100;
var custom_cur_time = 0;
var texture_name = null;

CustomLoadingLayer = cc.Layer.extend({
    listener_back:null,
//	_progress:null,
    layer_back:null,
    layer_listener:null,
    _cb:null,
    ctor:function (name ,length, cb){
        this._super();

        this._cb = cb;
        texture_name = name;
        custom_cur_index = 0;
        custom_resource_length = length;

        this.createComponents();

        this.loadResource();

        this.scheduleUpdate();
    },

    createComponents:function(){
        var size = cc.winSize;

        this.layer_back = new cc.LayerColor(cc.color("#000000"), size.width, size.height);
        this.layer_back.opacity = 0;
        this.layer_back.x = 0;
        this.layer_back.y = 0;
        this.addChild(this.layer_back, 0);

        var self = this;
        var layer_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                cc.log("touch begin");
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());

                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode)) {
                    return false;
                }

                return false;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {
            }
        });
        this.layer_listener = layer_listener.clone();
        this.layer_listener.retain();

        cc.eventManager.addListener(this.layer_listener, this.layer_back);

//		this._progress = new cc.Sprite("res/play/snake/bubble.png");
//		this._progress.x = size.width / 2;
//		this._progress.y = size.height / 2;
//		this._progress.scale = 1.5;
//		this.addChild(this._progress);
    },
    loadResource:function(){

//		this._progress.runAction(cc.repeatForever(cc.rotateBy(1, 360, 360)));

        var self = this;

        for (var index = 0; index < custom_resource_length; ++index) {
            console.log("kag:"+textureOrPlistPath(texture_name, 1 + index, "pvr.ccz"));
            cc.textureCache.addImageAsync(textureOrPlistPath(texture_name, 1 + index, "pvr.ccz"), function() {
                console.log("kag:"+textureOrPlistPath(texture_name, 1 + custom_cur_index, "plist"));
                cc.spriteFrameCache.addSpriteFrames(textureOrPlistPath(texture_name, 1 + custom_cur_index, "plist"));
                custom_cur_index++;
                self.checkCurTime();
            });
        }
    },
    checkCurTime:function(){
        if(custom_cur_index >= custom_resource_length){
            if (this._cb) {
                this._cb();
            }

            this.removeFromParent(true);
        }
    }
});
