var ShaYuLayer = cc.Layer.extend({
	arry_jelly_fish:null,
	arry_tooth:null,
	sprite_shayu:null,
	sprite_fish:null,
	
	sprite_fish_back:null,
    
    an_jelly:null,
    an_shayu_0:null,
    an_shayu_1:null,
    an_shayu_2:null,
    an_shayu_3:null,
    an_shayu_mouth:null,
    an_fish_eye:null,
    an_fish_swim:null,
    
    tooth_select:null,
    
    arry_tooth_listener:null,
    
    shayu_listener:null,
    
    tips_rand:null,
    
    n_cur_tooth:null,

    star_ad:null,
    
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        GlobalADIndex++;
        this._super();
        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
        
        this.n_cur_tooth = 0;

		popSceneMenu(this);
        this.createBack();
        
        this.createListener();
        
        this.loadAnimalRes();

        this.scheduleOnce(function(){
            cc.eventManager.addListener(this.shayujiao, this.sprite_shayu);
        },8.5);
        return true;
    },
    
    loadAnimalRes:function(){
    	var self = this;
    	this.addChild(new CustomLoadingLayer("shayu", 12, function() {
    		cc.log("loading finish!!!");
    		self.createAllAnimation();
    		self.createComp();
    		self.addListener();
    	}), 50);
    },
    createComp:function(){
    	this.arry_jelly_fish = [null, null, null, null];
    	for (var n_jelly = 0; n_jelly < 4; n_jelly++) {
    		this.arry_jelly_fish[n_jelly] = new cc.Sprite(cc.spriteFrameCache.getSpriteFrame("shayu-shuimu1.png"));
    		this.arry_jelly_fish[n_jelly].x = Config_Play.shayu.arry_jelly.begin[n_jelly].x;
    		this.arry_jelly_fish[n_jelly].y = Config_Play.shayu.arry_jelly.begin[n_jelly].y;
    		this.arry_jelly_fish[n_jelly].scale = Config_Play.shayu.arry_jelly.scale[n_jelly];
    		this.addChild(this.arry_jelly_fish[n_jelly], 1 + n_jelly);
    		this.arry_jelly_fish[n_jelly].runAction(cc.repeatForever(cc.animate(this.an_jelly)));
		}
    	
    	this.arry_jelly_fish[0].runAction(cc.repeatForever(cc.sequence(
    			cc.moveTo(Config_Play.shayu.arry_jelly.interval[0], Config_Play.shayu.arry_jelly.end[0]),
    			cc.callFunc(function() {
    				this.arry_jelly_fish[0].x = Config_Play.shayu.arry_jelly.begin[0].x;
    				this.arry_jelly_fish[0].y = Config_Play.shayu.arry_jelly.begin[0].y;
    			}.bind(this)),
    			cc.delayTime(2)
    	)));
    	this.arry_jelly_fish[1].runAction(cc.repeatForever(cc.sequence(
    			cc.moveTo(Config_Play.shayu.arry_jelly.interval[1], Config_Play.shayu.arry_jelly.end[1]),
    			cc.callFunc(function() {
    				this.arry_jelly_fish[1].x = Config_Play.shayu.arry_jelly.begin[1].x;
    				this.arry_jelly_fish[1].y = Config_Play.shayu.arry_jelly.begin[1].y;
    			}.bind(this)),
    			cc.delayTime(2)
    	)));
    	this.arry_jelly_fish[2].runAction(cc.repeatForever(cc.sequence(
    			cc.moveTo(Config_Play.shayu.arry_jelly.interval[2], Config_Play.shayu.arry_jelly.end[2]),
    			cc.callFunc(function() {
    				this.arry_jelly_fish[2].x = Config_Play.shayu.arry_jelly.begin[2].x;
    				this.arry_jelly_fish[2].y = Config_Play.shayu.arry_jelly.begin[2].y;
    			}.bind(this)),
    			cc.delayTime(2)
    	)));
    	this.arry_jelly_fish[3].runAction(cc.repeatForever(cc.sequence(
    			cc.moveTo(Config_Play.shayu.arry_jelly.interval[3], Config_Play.shayu.arry_jelly.end[3]),
    			cc.callFunc(function() {
    				this.arry_jelly_fish[3].x = Config_Play.shayu.arry_jelly.begin[3].x;
    				this.arry_jelly_fish[3].y = Config_Play.shayu.arry_jelly.begin[3].y;
    			}.bind(this)),
    			cc.delayTime(2)
    	)));
    	
    	this.sprite_shayu = new AnimalSprite("shayu", 3);
    	this.sprite_shayu.x = Config_Play.shayu.pos_shayu.x;
    	this.sprite_shayu.y = Config_Play.shayu.pos_shayu.y;
    	this.addChild(this.sprite_shayu, 19);
    	
    	this.rightToothAnimation();
    	
    	this.arry_tooth = [null, null, null, null, null, null, null];
    	var arry_tooth_name = ["shayu-yachi1", "shayu-yachi2", "shayu-yachi2", "shayu-yachi3", "shayu-yachi4", "shayu-yachi4", "shayu-yachi1", "shayu-yachi1", "shayu-yachi3"];
    	arry_tooth_name.reshuffle();
    	for (var n_tooth = 0; n_tooth < 9; n_tooth++) {
    		this.arry_tooth[n_tooth] = new MenuSingleSprite1(arry_tooth_name[n_tooth]);
    		this.arry_tooth[n_tooth].x = Config_Play.shayu.arry_tooth.pos[n_tooth].x;
    		this.arry_tooth[n_tooth].y = Config_Play.shayu.arry_tooth.pos[n_tooth].y;
    		this.arry_tooth[n_tooth].rotation = Config_Play.shayu.arry_tooth.rotation[n_tooth];
    		this.addChild(this.arry_tooth[n_tooth], 20 + n_tooth);
		}
    	
    	this.sprite_fish = new cc.Sprite(cc.spriteFrameCache.getSpriteFrame("xiaohongyu-youdong1.png"));
    	this.sprite_fish.x = Config_Play.shayu.fish_pos.begin.x;
    	this.sprite_fish.y = Config_Play.shayu.fish_pos.begin.y;
    	this.sprite_fish.scale = 0.6;
    	this.addChild(this.sprite_fish, 30);
    	
    	this.sprite_fish_back = new cc.Sprite(cc.spriteFrameCache.getSpriteFrame("xiaohongyu-youdong1.png"));
    	this.sprite_fish_back.x = Config_Play.shayu.fish_back_pos.x;
    	this.sprite_fish_back.y = Config_Play.shayu.fish_back_pos.y;
    	this.sprite_fish_back.scale = 0.4;
    	this.sprite_fish_back.setFlippedX(true);
    	this.addChild(this.sprite_fish_back, 5);

    	if (AD_ENABLE && ARRY_AD_IN && ARRY_AD_IN.length) {
    	     GlobalADIndex = (GlobalADIndex++)  % ARRY_AD_IN.length;
             this.star_ad = new StarAdLayer(ARRY_AD_IN[GlobalADIndex]);
             this.star_ad.x = cc.winSize.width - 85;
             this.star_ad.y = -15;
             this.addChild(this.star_ad, 650);
        }
    },
    
    createBack:function(){
    	var size = cc.winSize;

    	this.background = new cc.Sprite(backPath("shayu"));
    	this.background.x = size.width / 2;
    	this.background.y = size.height / 2;
    	this.addChild(this.background, 0);
    	resetScale(this.background);

    	var stone1 = new cc.Sprite(compPath("shayu", "stone1"));
    	stone1.x = Config_Play.shayu.pos_stone1.x;
    	stone1.y = Config_Play.shayu.pos_stone1.y;
    	this.addChild(stone1, 11);

    	var stone2 = new cc.Sprite(compPath("shayu", "stone2"));
    	stone2.x = Config_Play.shayu.pos_stone2.x;
    	stone2.y = Config_Play.shayu.pos_stone2.y;
    	this.addChild(stone2, 12);

    	var stone3 = new cc.Sprite(compPath("shayu", "stone3"));
    	stone3.x = Config_Play.shayu.pos_stone3.x;
    	stone3.y = Config_Play.shayu.pos_stone3.y;
    	this.addChild(stone3, 13);

    	createShakeNode(compPath("shayu", "grass1"), this, Config_Play.shayu.pos_grass1, 16, 5, cc.size(15, 100), 3, 4);
    	createShakeNode(compPath("shayu", "grass2"), this, Config_Play.shayu.pos_grass2, 17, 5, cc.size(15, 100), 3, 4);
    	createShakeNode(compPath("shayu", "grass3"), this, Config_Play.shayu.pos_grass3, 18, 5, cc.size(15, 100), 3, 4);
    },

    createAllAnimation:function(){
    	this.getAnimation("jelly");
    	this.getAnimation("mouth");
    	this.getAnimation("shayu0");
    	this.getAnimation("shayu1");
    	this.getAnimation("shayu2");
    	this.getAnimation("shayu3");
    	this.getAnimation("fish_eye");
    	this.getAnimation("fish_swim");
    },

    createAni:function(prefix, frame, duration){
    	var animation = new cc.Animation();
    	animation.setDelayPerUnit(duration);
    	animation.setRestoreOriginalFrame(false);
    	for (var n_index = 1; n_index < frame + 1; n_index++) {
    		animation.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(prefix + n_index + ".png"));
    	}
    	return animation;
    },
    getAnimation:function(ani_type){
    	switch (ani_type) {
    	case "jelly":
    	{
    		if (!this.an_jelly) {
    			this.an_jelly = this.createAni("shayu-shuimu", Config_Play.shayu.ani_info.jelly.f_number, Config_Play.shayu.ani_info.jelly.f_time);
    			this.an_jelly.retain();
    		}
    		return this.an_jelly;
    		break;
    	}
    	case "mouth":
    	{
    		if (!this.an_shayu_mouth) {
    			this.an_shayu_mouth = this.createAni("shayu-xiongmeng", Config_Play.shayu.ani_info.mouth.f_number, Config_Play.shayu.ani_info.mouth.f_time);
    			this.an_shayu_mouth.retain();
    		}
    		return this.an_shayu_mouth;
    		break;
    	}
    	case "shayu0":
    	{
    		if (!this.an_shayu_0) {
    			this.an_shayu_0 = this.createAni("shayu-huangdong", Config_Play.shayu.ani_info.tooth0.f_number, Config_Play.shayu.ani_info.tooth0.f_time);
    			this.an_shayu_0.retain();
    		}
    		return this.an_shayu_0;
    		break;
    	}
    	case "shayu1":
    	{
    		if (!this.an_shayu_1) {
    			this.an_shayu_1 = this.createAni("shayu-1yachi", Config_Play.shayu.ani_info.tooth1.f_number, Config_Play.shayu.ani_info.tooth1.f_time);
    			this.an_shayu_1.retain();
    		}
    		return this.an_shayu_1;
    		break;
    	}
    	case "shayu2":
    	{
    		if (!this.an_shayu_2) {
    			this.an_shayu_2 = this.createAni("shayu-2yachi", Config_Play.shayu.ani_info.tooth2.f_number, Config_Play.shayu.ani_info.tooth2.f_time);
    			this.an_shayu_2.retain();
    		}
    		return this.an_shayu_2;
    		break;
    	}
    	case "shayu3":
    	{
    		if (!this.an_shayu_3) {
    			this.an_shayu_3 = this.createAni("shayu-3yachi", Config_Play.shayu.ani_info.tooth3.f_number, Config_Play.shayu.ani_info.tooth3.f_time);
    			this.an_shayu_3.retain();
    		}
    		return this.an_shayu_3;
    		break;
    	}
    	case "fish_eye":
    	{
    		if (!this.an_fish_eye) {
    			this.an_fish_eye = this.createAni("xiaohongyu-biyan", Config_Play.shayu.ani_info.fish_eye.f_number, Config_Play.shayu.ani_info.fish_eye.f_time);
    			this.an_fish_eye.retain();
    		}
    		return this.an_fish_eye;
    		break;
    	}
    	case "fish_swim":
    	{
    		if (!this.an_fish_swim) {
    			this.an_fish_swim = this.createAni("xiaohongyu-youdong", Config_Play.shayu.ani_info.fish_swim.f_number, Config_Play.shayu.ani_info.fish_swim.f_time);
    			this.an_fish_swim.retain();
    		}
    		return this.an_fish_swim;
    		break;
    	}
    	default:
    		break;
    	}
    },
    
    createListener:function(){
    	var self = this;


    	this.shayujiao = cc.EventListener.create({
            		event: cc.EventListener.TOUCH_ONE_BY_ONE,
            		swallowTouches: true,
            		onTouchBegan: function (touch, event) {
            			var target = event.getCurrentTarget();
            			var locationInNode = target.convertToNodeSpace(touch.getLocation());

            			var s = target.getContentSize();
            			var rect = cc.rect(0, 0, s.width, s.height);

            			if (cc.rectContainsPoint(rect, locationInNode)) {
            			    cc.log("shayujiao........");
            				ddStopAllEffects();
            				ddPlayEffect("effect","res/shayu/audio/effect/shayuteng.mp3",false);
            			}
            			return false;
            		}
        });
        this.shayujiao.retain();
    	
    	var sprite_listener = cc.EventListener.create({
    		event: cc.EventListener.TOUCH_ONE_BY_ONE,
    		swallowTouches: true,
    		onTouchBegan: function (touch, event) {
    			self.tooth_select = null;
    			var target = event.getCurrentTarget();
    			var locationInNode = target.convertToNodeSpace(touch.getLocation());

    			var s = target.getContentSize();
    			var rect = cc.rect(0, 0, s.width, s.height);

    			if (cc.rectContainsPoint(rect, locationInNode)) {
    			    cc.log("touched........");
    				ddStopAllAudios();
    				if(-1 != self.isTooth(target) && target.isEnable()) {
    					self.tooth_select = target;
    					self.tooth_select.scale = 1.1;
    					return true;
    				} 
    				else {
    					self.checkShayu(target);
    					self.tooth_select = null;
					}
    			}
    			self.tooth_select = null;
    			return false;
    		},
    		onTouchMoved: function (touch, event) {
    			var delta = touch.getDelta();
    			if(self.tooth_select){
    				self.tooth_select.x += delta.x;
    				self.tooth_select.y += delta.y;
    			}
    		},
    		onTouchEnded: function (touch, event) {
    			if (self.tooth_select) {
    				self.tooth_select.scale = 1;
    				self.checkToothSelect();
				}
    		}
    	});
    	
    	this.arry_tooth_listener = [null, null, null, null, null, null, null, null, null];
    	for (var n_listener = 0; n_listener < 9; n_listener++) {
    		this.arry_tooth_listener[n_listener] = sprite_listener.clone();
    		this.arry_tooth_listener[n_listener].retain();
		}
    	
    	this.shayu_listener = sprite_listener.clone();
    	this.shayu_listener.retain();
    },
    
    addListener:function(){
    	for (var n_listener = 0; n_listener < 9; n_listener++) {
    		cc.eventManager.addListener(this.arry_tooth_listener[n_listener], this.arry_tooth[n_listener]);
		}
    },
    
    removeListener:function(){
    	for (var n_listener = 0; n_listener < 9; n_listener++) {
    		cc.eventManager.removeListener(this.arry_tooth_listener[n_listener]);
    	}
    },
    
    pauseListener:function(){
    	for (var n_listener = 0; n_listener < 9; n_listener++) {
    		cc.eventManager.pauseTarget(this.arry_tooth[n_listener], true);
    	}
    },
    
    resumeListener:function(){
    	for (var n_listener = 0; n_listener < 9; n_listener++) {
    		cc.eventManager.resumeTarget(this.arry_tooth[n_listener], true);
    	}
    },
    
    bindDragonListener:function(){
    	cc.eventManager.addListener(this.shayu_listener, this.sprite_shayu);
    },
    
    isTooth:function(target){
    	for (var n_index = 0; n_index < 9; ++n_index) {
			if (target == this.arry_tooth[n_index]) {
//				ddPlayEffect("effect", soundPath(null, "click", null), false);
				return n_index;
			}
		}
    	
    	return -1;
    },
    
    checkShayu:function(target){
    	if (target == this.sprite_shayu && this.sprite_shayu.isEnable()) {
    		this.sprite_shayu.setEnable(false);
    		this.sprite_shayu.stopAllActions();
    		this.sprite_shayu.runAction(cc.sequence(
    			cc.spawn(
    				cc.callFunc(function(){
    					ddStopAllEffects();
						ddPlayEffect("effect","res/shayu/audio/effect/shayuhungry.mp3",false);
					}),
    				cc.animate(this.an_shayu_mouth)
				),
    			cc.callFunc(
    				function() {
    					this.sprite_shayu.setEnable(true);
    					this.sprite_shayu.runAction(cc.repeatForever(cc.animate(this.an_shayu_0)));
					}.bind(this)
    			)
    		));

    	}
    },
    checkToothSelect:function(){
    	if (this.tooth_select) {
    		if (this.tooth_select.isEnable()) {
    			if (this.tooth_select.frameName() == "shayu-yachi1") {
					ddStopAllAudios();
					ddPlayEffect("effect","res/shayu/audio/effect/toothright.mp3",false);
					console.log("correct select!!!");
					this.pauseListener();
					this.tooth_select.setEnable(false);
					this.tooth_select.runAction(cc.sequence(
						cc.moveTo(0.2, Config_Play.shayu.tooth_end),
						cc.fadeTo(0.1, 0),
						cc.callFunc(function() {
							this.n_cur_tooth++;
							this.rightToothAnimation();
						}.bind(this))
					));
				} else {
					ddStopAllAudios();
					ddPlayEffect("effect","res/shayu/audio/effect/tootherror.mp3",false);
					console.log("wrong select");
					var n_index = this.isTooth(this.tooth_select);
					if (-1 != n_index) {
						this.wrongToothAnimation(this.tooth_select, n_index);
					}else {
						this.tooth_select = null;
					}
					
				}
			}else {
				ddStopAllAudios();
				ddPlayEffect("effect","res/shayu/audio/effect/tootherror.mp3",false);
				console.log("already selected!!!");
			}
		}
    },
    wrongToothAnimation:function(target, index){
    	this.pauseListener();
    	target.runAction(cc.sequence(
    			cc.spawn(cc.moveBy(0.3, cc.p(0, -this.tooth_select.y - 100)), cc.fadeTo(0.3, 0)),
    			cc.callFunc(function() {
    				this.tooth_select.x = Config_Play.shayu.arry_tooth.pos[index].x;
    				this.tooth_select.y = Config_Play.shayu.arry_tooth.pos[index].y;
				}.bind(this)),
				cc.delayTime(0.1),
				cc.fadeTo(0.2, 255),
				cc.callFunc(function() {
					this.tooth_select = null;
					this.resumeListener();
				}.bind(this))
    	));
    },
    rightToothAnimation:function(){
    	switch (this.n_cur_tooth) {
    		case 0:
    		{
    			this.sprite_shayu.stopAllActions();
    			this.sprite_shayu.runAction(cc.repeatForever(cc.animate(this.an_shayu_3)));
    			break;
    		}
			case 1:
			{
				this.sprite_shayu.stopAllActions();
				this.sprite_shayu.runAction(cc.repeatForever(cc.animate(this.an_shayu_2)));
				this.resumeListener();
				break;
			}
			case 2:
			{
				this.sprite_shayu.stopAllActions();
				this.sprite_shayu.runAction(cc.repeatForever(cc.animate(this.an_shayu_1)));
				this.resumeListener();
				break;
			}
			case 3:
			{
				this.sprite_shayu.stopAllActions();
				this.sprite_shayu.setEnable(true);
				this.sprite_shayu.runAction(cc.repeatForever(cc.animate(this.an_shayu_0)));
				this.toothFinish();
				break;
			}
			default:
			{
				this.resumeListener();
				break;
			}
    	}
    },
    toothFinish:function(){
		ddPlayEffect("effect","res/shayu/audio/music/shayu2.mp3",false);
    	for (var n_tooth = 0; n_tooth < 9; n_tooth++) {
			this.arry_tooth[n_tooth].setVisible(false);
		}
    	this.bindDragonListener();
    	
    	var ani_swim = cc.repeat(
    			cc.animate(this.an_fish_swim), 
    			Config_Play.shayu.swim_time / (Config_Play.shayu.ani_info.fish_swim.f_number * Config_Play.shayu.ani_info.fish_swim.f_time)
    	);
    	var size = cc.winSize;
    	this.sprite_fish_back.runAction(cc.repeatForever(
    		cc.sequence(
    			cc.spawn(cc.moveBy(6, cc.p(size.width + 200, 0)), 
    				cc.repeat(
    					cc.animate(this.an_fish_swim), 
    					6 / (Config_Play.shayu.ani_info.fish_swim.f_number * Config_Play.shayu.ani_info.fish_swim.f_time)
    				)
    			),
    			cc.callFunc(function() {
    				this.sprite_fish_back.x = Config_Play.shayu.fish_back_pos.x;
    				this.sprite_fish_back.y = Config_Play.shayu.fish_back_pos.y;
    			}.bind(this))
        )));
    	
    	this.sprite_fish.runAction(cc.repeatForever(
    			cc.sequence(
    					cc.callFunc(function() {
    						this.sprite_fish.setFlippedX(true);
						}.bind(this)),
						cc.spawn(
							cc.moveTo(Config_Play.shayu.swim_time, Config_Play.shayu.fish_pos.end), 
							ani_swim
						), 
    					cc.callFunc(function() {
    						this.checkShayu(this.sprite_shayu);
						}.bind(this)),
						cc.animate(this.an_fish_eye),
    					cc.callFunc(function() {
    						this.sprite_fish.setFlippedX(false);
    					}.bind(this)),
    					cc.spawn(cc.moveTo(Config_Play.shayu.swim_time, Config_Play.shayu.fish_pos.begin), ani_swim),
    					cc.delayTime(5)
    	)));
    },
	releaseRes:function(){
	    ddStopAllAudios();
    	this.cleanScene();
	},
    cleanScene:function(){
        closeStarAd(this.star_ad);
    	this.unscheduleAllCallbacks();
    	this.sprite_shayu.stopAllActions();
    	this.sprite_fish_back.stopAllActions();
    	this.sprite_fish.stopAllActions();
    	
    	for (var n_listener = 0; n_listener < 9; n_listener++) {
    		releaseObj(this.arry_tooth_listener[n_listener]);
		}
    	
    	releaseObj(this.shayu_listener);
    	releaseObj(this.shayujiao);

    	releaseObj(this.an_jelly);
    	releaseObj(this.an_shayu_0);
    	releaseObj(this.an_shayu_1);
    	releaseObj(this.an_shayu_2);
    	releaseObj(this.an_shayu_3);
    	releaseObj(this.an_shayu_mouth);
    	releaseObj(this.an_fish_eye);
    	releaseObj(this.an_fish_swim);

    	cc.textureCache.removeAllTextures();
    	cc.spriteFrameCache.removeSpriteFrames();
    },
    onExitTransitionDidStart:function(){

    }
});

var ShaYuScene = cc.Scene.extend({
	ctor:function(){
		this._super();
        ddStopAllAudios();
        umengEvent("fish_type", "ShaYu");
		this.scheduleOnce(function(){
		    cc.audioEngine.setMusicVolume(1);
            cc.audioEngine.setEffectsVolume(1);
        	ddStopAllAudios();
			ddPlayEffect("music","res/shayu/audio/music/shayu1.mp3",false);
		},1);

		var layer_dragon = new ShaYuLayer();
		this.addChild(layer_dragon);
	},
    onEnter:function(){
        this._super();
        ddStopAllAudios();
        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
    }
});

