var Emitter = cc.Node.extend({
    emitSpeed:null,
    emitInterval:null,
    emitElastic:null,

    locationHigh:null,
    locationLow:null,
    constPosHigh:null,
    constPosLow:null,
    ctor:function(emitkind,emitSpeed,emitElastic,emitInterval){
        this._super();
        this.initData(emitSpeed,emitElastic,emitInterval);
        this.emitkind = parseInt(emitkind);
        cc.log("Emitter constructor!");
    },
    initData:function(emitSpeed,emitElastic,emitInterval){
        this.constPosHigh = cc.p(Config_Play.haixing.emitBeginX,Config_Play.haixing.emitHigh);
        this.constPosLow  = cc.p(Config_Play.haixing.emitBeginX,Config_Play.haixing.emitLow);
        this.locationHigh = cc.p(0,Config_Play.haixing.emitHigh);
        this.locationLow  = cc.p(0,Config_Play.haixing.emitLow);
        this.emitSpeed = parseFloat(emitSpeed);
        this.emitInterval = parseFloat(emitInterval);
        this.emitElastic = parseFloat(emitElastic);
    },
    startSchedule:function(){
        cc.log("startschedule........");
        this.createRandPos();
        var spr = HaixingSprite.reCreateRand(this.emitSpeed,GlobalHaixingGrade);
        this.addChild(spr,65535);
        if(1 == this.emitkind){
            spr.setPosition(this.locationHigh);
        }else{
            spr.setPosition(this.locationLow);
        }
    },
    startEmit:function(){
        this.schedule(this.startSchedule,this.emitInterval,cc.REPEAT_FOREVER,0.1);
    },
    stopEmit:function(){
        this.unschedule(this.startSchedule);
    },
    setEmitterSpeed:function(emitSpeed){
        this.emitSpeed = emitSpeed;
    },
    setEmitInterval:function(emitInterval){
        this.emitInterval = emitInterval;
    },
    setEmitElastic:function(emitElastic){
        this.emitElastic = emitElastic;
    },
    createRandPos:function(){
        if(1 == this.emitkind) {
            this.locationHigh = cc.p(this.constPosHigh.x,this.constPosHigh.y);
            this.elastics(this.locationHigh);
        }else {
            this.locationLow = cc.p(this.constPosLow.x,this.constPosLow.y);
            this.elastics(this.locationLow);
        }
    },
    elastics:function(target){
        var idx = getRand0ToN(3);
        if(1 == idx){
            target.x -= this.emitElastic;
        }else if(2 == idx){
        }else{
            target.x += this.emitElastic;
        }

        var idx2 = getRand0ToN(3);
        if(1 == idx2){
            target.y -= this.emitElastic;
        }else if(2 == idx2){
        }else{
            target.y += this.emitElastic;
        }
    }
});