var HetunLayer = SmallLayer.extend({
    couldScale:null,
    scales:null,
    randMove:null,
    ctor:function(){
        this._super();

        this.couldScale = false;
        this.scales = 1;
        this.randMove = false;
    },
    loadRes:function(){
        cc.log("loadRes-hetun");
    },
    addDynamic:function(){
        cc.log("addDynamic-hetun");
    },
    addBackground: function () {
        this.background = createStaticNode("res/ankang/background.png", this, cc.p(GW2, GH2), 0);
        resetScale(this.background);
    },
    addHetun:function(){
        var self = this;
        cc.log("addStatic-hetun");
        this.hetun = new cc.Sprite("res/200x200.png",cc.rect(0,0,20,20));
        this.addChild(this.hetun);
        this.hetun.setPosition(GW2,GH2);

        this.hetun.onTouchBegan = function(touch,event){
            var target = event.getCurrentTarget();
            var locationInNode = target.convertToNodeSpace(touch.getLocation());
            var s = target.getContentSize();
            var rect = cc.rect(0, 0, s.width, s.height);
            if (cc.rectContainsPoint(rect, locationInNode)) {
                self.couldScale = true;
                cc.log("began");
            }
            return true;
        }
        this.hetun.onTouchEnded = function(touch,event){
            cc.log("ended");
            self.couldScale = false;
            if(self.randMove){
                cc.log("开始randommove");
            }
        }
        registerTouchEventOneByOne(this.hetun,true,this.hetun);
        this.scheduleUpdate();
    },
    addStatic:function(){
        this.addBackground();
        this.addHetun();
    },
    update:function(dt){
        if(this.couldScale){
            if(this.hetun.getScale() < 8) {
                this.scales += dt;
                this.hetun.setScale(this.scales, this.scales);
            }else{
                //发送一个信号使得当touchend的时候河豚自己无规则运动
                this.randMove = true;
            }
        }
    }
});

var HetunScene = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new HetunLayer();
        this.addChild(layer);
    }
});