var GlobalJianyuLayer = null;
var JianyuLayer = SmallLayer.extend({
    star_ad:null,
    ctor:function(){
    GlobalADIndex++;
        this._super();


        popSceneMenu(this);
        this.addBackground();
        this.addSpeak();
        // this.scheduleOnce(function(){
        //     this.loadRes1();
        //     this.addStatic1();
        //     this.addDynamic1();
        // },10);

        GlobalJianyuLayer = this;
    },
    addSpeak:function(){
        this.jianyuspeak = createSkeletonAnimation("res/jianyu/skeleton/XIG1.json", "res/jianyu/skeleton/XIG1.atlas", 0.8,this, cc.p(-500,GH2), 100, 0, "normal", true);
        this.jianyuspeak.setScale(0.6);
        this.jianyuspeak.setTimeScale(1);//设置动画播放快慢

        var self = this;
        this.jianyuspeak.runAction(cc.sequence(
            cc.moveTo(0.8,GW2-300,GH2).easing(cc.easeIn(3)),
            cc.callFunc(
                function(){
                    self.jianyuspeak.setAnimation(0,"talk",true);
                    ddPlayEffect("music","res/jianyu/audio/music/jianyu.mp3");
                }
            ),
            cc.delayTime(3),
            cc.callFunc(
                function(){
                    self.jianyuspeak.setAnimation(0,"happy",1);
                    self.jianyuspeak.setTimeScale(1.4);
                }
            ),
            cc.delayTime(3.5),
            cc.callFunc(
                function(){
                    self.jianyuspeak.setAnimation(0,"normal",true);
                }
            ),
            cc.moveTo(0.9,GW+300,GH2).easing(cc.easeOut(2)),
            cc.callFunc(function(){
                self.loadRes1();
                self.addStatic1();
                self.addDynamic1();
            })
        ));
    },
    loadRes1:function(){
        cc.log("loadRes-jianyu");
    },
    addDynamic1:function(){
        cc.log("addDynamic-jianyu");
        this.addSpine();
    },
    addSpine: function () {//happy normal talk
        this.jianyu = createSkeletonAnimation("res/jianyu/skeleton/XIG1.json", "res/jianyu/skeleton/XIG1.atlas", Config_Play.jianyu.scale, this, Config_Play.jianyu.position, 65535, 0, "normal", true);
        this.jianyu.setScale(1);
        this.jianyu.setTimeScale(1);//设置动画播放快慢
        this.jianyu.setMix("talk","normal",1);
        this.jianyu.setMix("happy","normal",1);

        this.jianyupengzhuang = new cc.Sprite("res/200x200.png",cc.rect(0,0,65,20));
        this.jianyupengzhuang.setPosition(290,30);
        this.jianyupengzhuang.setVisible(false);
        this.jianyu.addChild(this.jianyupengzhuang);//jianyuchild
    },
    addStatic1: function () {
        cc.log("addStatic-jianyu");
        this.addEmitter();
        // this.addBackground();
        this.addTouchListener();
        this._touchY = GH2;//0
        this._touchX = 0;
        //this.test();
    },
    test:function(){
        this.small = new cc.Sprite("res/200x200.png",cc.rect(0,0,30,15));
        this.addChild(this.small);
        this.small.setPosition(500,GH2+30);


        //var spr = new cc.Sprite("res/200x200.png",cc.rect(0,0,90,90));
        this.qi = new cc.Sprite("res/jianyu/texture/qiqiu1.png");
        this.addChild(this.qi);
        this.qi.setScale(0.8);//0.8
        this.qi.setPosition(800,240);

        var large = new cc.Sprite("res/200x200.png",cc.rect(0,0,90,90));
        large.setTag(100);
        this.qi.addChild(large);
        large.setPosition(64,260);
    },
    addEmitter:function(){
        cc.log("发射器");
        var emitter = new EmitterQiqiu(this,1.2,0.7);
        emitter.startEmit();
        this.addChild(emitter);
    },
    addBackground: function () {
        this.background = createStaticNode("res/jianyu/texture/background.png", this, cc.p(GW2, GH2), 0);
        resetScale(this.background);
        createStaticNode("res/jianyu/texture/shitou1.png", this, cc.p(GW - 90, 120), 110);
        createStaticNode("res/jianyu/texture/shitou2.png", this, cc.p(180, 120), 110);
        createStaticNode("res/jianyu/texture/shitou3.png", this, cc.p(120, 100), 150);
        createShakeNode("res/jianyu/texture/shuicao1.png", this, cc.p(125, 180), 125, 5, cc.size(15, 100), 3, 10);
        createShakeNode("res/jianyu/texture/shuicao2.png", this, cc.p(215, 140), 135, 5, cc.size(15, 100), 3, 10);
        createShakeNode("res/jianyu/texture/shuicao3.png", this, cc.p(GW-130,100), 500, 5, cc.size(15, 100), 3, 10);

        if (AD_ENABLE && ARRY_AD_IN && ARRY_AD_IN.length) {
             GlobalADIndex = (GlobalADIndex++)  % ARRY_AD_IN.length;
             this.star_ad = new StarAdLayer(ARRY_AD_IN[GlobalADIndex]);
             this.star_ad.x = cc.winSize.width - 85;
             this.star_ad.y = -15;
             this.addChild(this.star_ad, 650);
        }
    },
    addTouchListener:function(){
        var self = this;
        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                //cc.log("touch.x"+touch.getLocationX()+",touch.y"+touch.getLocationY());
                //cc.director.pause();
                self._touchX = touch.getLocationX();
                self._touchY = touch.getLocationY();
                return true;
            },
            onTouchMoved:function(touch,event){
                self._touchX = touch.getLocationX();
                self._touchY = touch.getLocationY();
            },
            onTouchEnded:function(touch,event){
                self._touchX = touch.getLocationX();
                self._touchY = touch.getLocationY();
            }
        });
        cc.eventManager.addListener(sprite_listener.clone(), this);
        this.scheduleUpdate();
    },
    handlePosition:function() {
        this.jianyu.y -= (this.jianyu.y - this._touchY) * 0.1;


        if (Math.abs(-(this.jianyu.y - this._touchY) * 0.2) < 30)
            this.jianyu.setRotation((this.jianyu.y - this._touchY) * 0.2);


        if (this.jianyu.y < this.jianyu.height * 0.5)
        {
            this.jianyu.y = this.jianyu.height * 0.5;
            this.jianyu.setRotation(0);
        }
        if (this.jianyu.y > cc.director.getWinSize().height - this.jianyu.height/2)
        {
            this.jianyu.y = cc.director.getWinSize().height - this.jianyu.height/2;
            this.jianyu.setRotation(0);
        }
    },
    update:function(){
        this.handlePosition();
    },
    unregisterAllEvents:function(){

    },
    releaseRes:function(){
        ddStopAllAudios();
        closeStarAd(this.star_ad);
        this.unregisterAllEvents();
        this.cleanScene();
        cc.pool.drainAllPools();
    },
    cleanScene:function(){
        this.unscheduleAllCallbacks();

        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
    }
});

var JianyuScene = cc.Scene.extend({
    ctor:function () {
        this._super();
        umengEvent("fish_type", "JianYu");
        cc.audioEngine.setMusicVolume(1);
        cc.audioEngine.setEffectsVolume(1);
        ddStopAllAudios();
        var layer = new JianyuLayer();
        this.addChild(layer);
    },
    onEnter:function(){
        this._super();
        ddStopAllAudios();
        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
    }
});