var NightLayer = cc.Layer.extend({
	ctor:function(){
		this._super();
		//this.addback();
		this.addNights();
	},
	addback:function(){
		var back = new cc.Sprite("res/bac.png");
		back.setPosition(1136/2,640/2);
		this.addChild(back);
	},
	addNights:function(){
		this.createLight1("res/zhangyu/texture/light1.png");
		this.createLight2("res/zhangyu/texture/light1.png");
		this.createLight3("res/zhangyu/texture/light1.png");
		this.createLight4("res/zhangyu/texture/light1.png");
		this.createLight5("res/zhangyu/texture/light1.png");
		this.createLight6("res/zhangyu/texture/light1.png");
	},
	createLight1:function(path,x,y,scale){
		var sprite = new cc.Sprite(path);
		sprite.setOpacity(80);
		sprite.setScale(1.1);
		sprite.setPosition(220,240);

		var rend = new cc.RenderTexture(1116,800);

		rend.setPosition(936,540);
		this.addChild(rend, 100);

		rend.begin();
		sprite.visit();
		rend.end();

		rend.getSprite().runAction(cc.repeatForever(
				cc.sequence(
						cc.fadeTo(getRand1ToN(3),250),
						cc.delayTime(getRand0ToN(2)),
						cc.fadeTo(getRand1ToN(7),20),
						cc.delayTime(getRand0ToN(3))
				)
		));
	},
	createLight2:function(path,x,y,scale){
		var sprite = new cc.Sprite(path);
		sprite.setOpacity(80);
		sprite.setScale(1);
		sprite.setPosition(10,150);

		var rend = new cc.RenderTexture(1136,640);

		rend.setPosition(560,580);
		this.addChild(rend, 100);

		rend.begin();
		sprite.visit();
		rend.end();

		rend.getSprite().runAction(cc.repeatForever(
				cc.sequence(
						cc.fadeTo(getRand1ToN(3),250),
						cc.delayTime(getRand0ToN(2)),
						cc.fadeTo(getRand1ToN(7),20),
						cc.delayTime(getRand0ToN(3))
				)
		));
	},
	createLight3:function(path){
		var sprite = new cc.Sprite(path);
		sprite.setOpacity(80);
		sprite.setScale(0.9);
		sprite.setPosition(440,280);

		var rend = new cc.RenderTexture(1836,1540);

		rend.setPosition(1570,990);
		this.addChild(rend, 100);

		rend.begin();
		sprite.visit();
		rend.end();

		rend.getSprite().runAction(cc.repeatForever(
				cc.sequence(
						cc.fadeTo(getRand1ToN(3),250),
						cc.delayTime(getRand0ToN(2)),
						cc.fadeTo(getRand1ToN(7),20),
						cc.delayTime(getRand0ToN(3))
				)
		));
	},
	createLight4:function(path,x,y,scale){
		var sprite = new cc.Sprite(path);
		sprite.setOpacity(80);
		sprite.setScale(1);
		sprite.setPosition(440,280);

		var rend = new cc.RenderTexture(1836,1540);

		rend.setPosition(1640,1040);
		this.addChild(rend, 100);

		rend.begin();
		sprite.visit();
		rend.end();

		rend.getSprite().runAction(cc.repeatForever(
				cc.sequence(
						cc.fadeTo(getRand1ToN(3),250),
						cc.delayTime(getRand0ToN(2)),
						cc.fadeTo(getRand1ToN(7),20),
						cc.delayTime(getRand0ToN(3))
				)
		));
	},
	createLight5:function(path,x,y,scale){
		var sprite = new cc.Sprite(path);
		sprite.setOpacity(80);
		sprite.setScale(0.7);
		sprite.setPosition(220,240);

		var rend = new cc.RenderTexture(1006,640);

		rend.setPosition(1136,530);
		this.addChild(rend, 100);

		rend.begin();
		sprite.visit();
		rend.end();

		rend.getSprite().runAction(cc.repeatForever(
				cc.sequence(
						cc.fadeTo(getRand1ToN(3),250),
						cc.delayTime(getRand0ToN(2)),
						cc.fadeTo(getRand1ToN(7),20),
						cc.delayTime(getRand0ToN(3))
				)
		));
	},
	createLight6:function(path,x,y,scale){
		var sprite = new cc.Sprite(path);
		sprite.setOpacity(80);
		sprite.setScale(0.7);
		sprite.setPosition(220,240);

		var rend = new cc.RenderTexture(1006,640);

		rend.setPosition(1086,540);
		this.addChild(rend, 100);

		rend.begin();
		sprite.visit();
		rend.end();

		rend.getSprite().runAction(cc.repeatForever(
				cc.sequence(
						cc.fadeTo(getRand1ToN(3),250),
						cc.delayTime(getRand0ToN(2)),
						cc.fadeTo(getRand1ToN(7),20),
						cc.delayTime(getRand0ToN(3))
				)
		));
	}
});

var NightScene = cc.Scene.extend({
	ctor:function(){
		this._super();
		
		var layer = new NightLayer();
		this.addChild(layer);
	}
});