var XiaohongyuBlack = cc.Sprite.extend({
    ctor:function(path,index){
        this._super(path);
        this.couldclick = true;
        this.curstate = 1;//0 running,1 stand
        this.idx = index;
        this.createActions();
        this.randWhiteState();
        this.scheduleUpdate();
    },
    createActions:function(){
        this.whitestopaction = cc.repeatForever(
            cc.sequence(
                newAnimationCreate(11,"xiaohongyu-zhenyan",0.1,getRand1ToN(3),false),
                newAnimationCreate(9,"xiaohongyu-biyan",0.1,getRand1ToN(2),false)
                // newAnimationCreate(13,"xiaohongyu-youdong",0.1,getRand1ToN(5),false)
            ));
        this.whitestopaction.retain();
    },
    randWhiteState:function(){
        this.stopAllActions();
        this.runAction(this.whitestopaction);
    },
    switchToBlack:function(){
        cc.log("切换到黑色");
        this.stopAllActions();
        this.runAction(cc.repeatForever(newAnimationCreate(13,"xiaohongyu-mozhi",0.1,1,false)));
    },
    runtoacircle:function(){
        cc.log("run to left");
        this.stopAllActions();
        var self = this;
        this.runAction(cc.sequence(
            cc.callFunc(function(){
                self.couldclick = false;
                self.curstate = 0;
            }),
            cc.spawn(
                cc.moveBy(3,-1310,0).easing(cc.easeInOut(1)),
                cc.repeat(newAnimationCreate(13,"xiaohongyu-youdong",0.05,1,false),5)
            ),
            cc.callFunc(function(){
                //恢复接收时间通知
                self.curstate = 1;
                self.couldclick = true;
                self.randWhiteState();
            })
        ));
    },
    update:function(){
        if(this.x < -100){
            this.x = 1200;
        }
    }
});

var XiaohongyuRun= cc.Sprite.extend({
    ctor:function(path,idx){
        this._super(path);
        this.idx = idx;
        this.runAction(cc.repeatForever(newAnimationCreate(13,"xiaohongyu-youdong",0.05,1,false)));
    },
    update:function(){
        this.x -= 1;
        if(this.x < -100){
            this.x = 1200;
        }
        if(Math.abs(this.getPositionX() - Config_Play.zhangyu.xiaoyupos[this.idx].x) < 3){
            cc.log("pause");
            //this.pause();
            this.randWhiteState();
        }
    }
});