var GlobalZhangyuLayer = null;
var zhangyuTouchCouldEnter = true;
var ZhangyuLaye = SmallLayer.extend({
    star_ad:null,
    ctor:function(){
        GlobalADIndex++;
        zhangyuTouchCouldEnter = true;
        this._super();
        popSceneMenu(this);
        GlobalZhangyuLayer = this;
    },
    recvEvents:function(){
        var self = this;
        cc.log("enter zhangyulayer recvEvents!");
        recvCustomEvent("tell_zhangyu_happy",function(event){
            self.zhangyu.setAnimation(1,"zhangyukaixin",false);
            ddPlayEffect("effect","res/zhangyu/audio/effect/laugh.mp3",false);
        });
    },
    addDynamic: function () {
        this.addSpine();
        this.addShakeNode();
        this.addtestListener();
    },
    addStatic:function(){
        this.addBackground();
        this.addStones();

        var size = cc.winSize;
        if (AD_ENABLE && ARRY_AD_IN && ARRY_AD_IN.length) {
             GlobalADIndex = (GlobalADIndex++)  % ARRY_AD_IN.length;
             this.star_ad = new StarAdLayer(ARRY_AD_IN[GlobalADIndex]);
             this.star_ad.x = cc.winSize.width - 85;
             this.star_ad.y = - 15;
             this.addChild(this.star_ad, 350);
        }
    },
    loadRes:function(){
        var self = this;
        cc.log("loadRes-zhangyu");
        cc.textureCache.addImageAsync("res/zhangyu/texture/xiaohongyu.pvr.ccz", function() {
            cc.spriteFrameCache.addSpriteFrames("res/zhangyu/texture/xiaohongyu.plist");
            self.addXiaoyu();
        });
    },
    addXiaoyu:function(){
        this.xiaoyu = [];
        this.xiaoyulisteners = [];
        var self = this;

        for(var i = 0;i < 5;i ++){
            this.xiaoyu[i] = new XiaohongyuBlack("#xiaohongyu-zhenyan1.png",i);
            this.xiaoyu[i].setScale(0.6);
            this.xiaoyu[i].isBlack = false;
            this.addChild(this.xiaoyu[i],300);
            this.xiaoyu[i].setPosition(Config_Play.zhangyu.xiaoyupos[i].x,Config_Play.zhangyu.xiaoyupos[i].y);
        }
        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());

                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode) && target.couldclick) {
                    ddStopAllAudios();
                    ddPlayEffect("effect","res/zhangyu/audio/effect/chaganjing.mp3",false);
                    cc.log("xiaoyu is clicked ");

                    target.runtoacircle();
                    // target.setTexture("res/test/2.png");
                    // target.randWhiteState();
                    target.isBlack = false;
                    target.resume();
                    var ret = true;
                    for(var i = 0;i < 5;i ++){
                        ret &= !self.xiaoyu[i].isBlack;
                    }
                    if(ret){
                        sendCustomEvent("tell_zhangyu_happy");
                    }
                }
            }
        });
        for(var i = 0;i < 5;i ++) {
            this.xiaoyulisteners[i] = sprite_listener.clone();
            cc.eventManager.addListener(this.xiaoyulisteners[i], this.xiaoyu[i]);
        }

        recvCustomEvent("tell_xiaohongyu_black",function(event){
            cc.log("收到消息，小鱼全变黑");
            var idx = parseInt(event.getUserData());

            cc.log("当前userdata:"+idx);
            self.scheduleOnce(function(){
                //for(var i = 0;i < 5;i ++){
                if(self.xiaoyu[idx].curstate == 1) {
                    self.xiaoyu[idx].isBlack = true;
                    self.xiaoyu[idx].switchToBlack();
                }
                //}
            },1);
        });

    },
    addBackground: function () {
        this.background = createStaticNode("res/zhangyu/background.png", this, cc.p(GW2, GH2), 0);
        resetScale(this.background);
        this.addChild(new NightLayer());
    },
    addStones: function () {
        createStaticNode("res/zhangyu/shanhushitou.png", this, cc.p(GW - 120, 120), 110);
        createStaticNode("res/zhangyu/shuicaoshitou.png", this, cc.p(100, GH2 - 60), 110);
    },
    addShakeNode: function () {
        this.shuicao = createShakeNode("res/zhangyu/shuicao.png", this, cc.p(115, 490), 5, 5, cc.size(15, 100), 3, 10);
        this.shanhu = createShakeNode("res/zhangyu/shanhu.png", this, cc.p(1000, 310), 5, 5, cc.size(15, 100), 3, 10);
    },
    addtumozhi: function () {
        if(this.particlesystem) {
            this.particlesystem.removeFromParent(true);
            this.particlesystem = null;
        }
        this.scheduleOnce(function(){
            this.particlesystem = new cc.ParticleSystem("res/zhangyu/zhangyutumozhi.plist");
            this.particlesystem.setAutoRemoveOnFinish(false);
            this.particlesystem.setPosition(1136 / 2 - 40, 640 / 2 + 50);
            this.addChild(this.particlesystem,10000);
            this.particlesystem.setDuration(0.5);
        },0.1);
        this.scheduleOnce(function(){
            zhangyuTouchCouldEnter = true;
        },1.6);

    },
    addSpine: function () {//zhangyuhuxi zhangyukaixin zhangyushuohua zhangyutumozhi
        var self = this;
        this.zhangyu = createSkeletonAnimation("res/zhangyu/skeleton/zhangyu.json", "res/zhangyu/skeleton/zhangyu.atlas", 0.8, this, cc.p(-100, GH2-100), 100, 1, "zhangyushuohua", true);
        this.zhangyu.setTimeScale(1);//设置动画播放快慢
        this.zhangyu.setMix("zhangyukaixin","zhangyuhuxi",1);
        this.zhangyu.setMix("zhangyushuohua","zhangyuhuxi",1);
        this.zhangyu.setMix("zhangyutumozhi","zhangyuhuxi",1);

        this.zhangyu.runAction(cc.moveTo(1.2,cc.p(GW2,GH2-100)).easing(cc.easeCircleActionInOut()));
        this.scheduleOnce(function(){
            cc.audioEngine.setMusicVolume(1);
            cc.audioEngine.setEffectsVolume(1);
            ddPlayEffect("music","res/zhangyu/audio/music/zhangyu.mp3");
        },0.9);
        this.scheduleOnce(function(){
            cc.log("改变");
            this.zhangyu.speakOver = true;//说话完成发送一个信号是的该变量为true
        },5.4);




        this.zhangyu.setStartListener(function(trackEntry){
            if(trackEntry){
                var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
                cc.log("start ! current trackEntry index is "+trackEntry.trackIndex+" and trackEntry name is " + animationName);
                switch(animationName){
                    case "zhangyushuohua":
                        break;
                    case "zhangyukaixin":
                        break;
                    case "zhangyuhuxi":
                        break;
                    case "zhangyutumozhi":
                        //发送信号使得所有小鱼变黑,所有小鱼变白后发送信号使得章鱼开心
                        GlobalZhangyuLayer.addtumozhi();
                        for(var i = 0;i < 5;i ++)
                            sendCustomEventAddUserData("tell_xiaohongyu_black",i);
                        break;
                    default :
                        break;
                }
            }else{
                cc.log("start ! tackEntry is null");
            }
        });
        this.zhangyu.setEndListener(function(trackEntry){
            if(trackEntry){
                var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
                cc.log("end ! current trackEntry index is "+trackEntry.trackIndex+" and trackEntry name is " + animationName);
            }else{
                cc.log("end ! tackEntry is null");
            }
        });
        this.zhangyu.setCompleteListener(function(trackEntry){
            if(trackEntry){
                var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
                var loopCount = Math.floor(trackEntry.trackTime / trackEntry.animationEnd);
                cc.log("completed ! current trackEntry index is "+trackEntry.trackIndex+" and trackEntry name is " + animationName +" and completed time is "+ loopCount);

                // if(5 == loopCount){
                //     cc.log("需要停止当前动作了");
                //     sendCustomEvent("kang")
                //     //self.zhangyu.addAnimation(1,"zhangyukaixin",true);
                // }
                switch(animationName){
                    case "zhangyushuohua":
                        cc.log("speakover:"+self.zhangyu.speakOver);
                        if(self.zhangyu.speakOver) {
                            self.zhangyu.setAnimation(1, "zhangyutumozhi", false);
                            ddStopAllAudios();
                            self.scheduleOnce(function(){
                                ddPlayEffect("effect","res/zhangyu/audio/effect/pengmozhi.mp3",false);
                            },0.7);

                            self.zhangyu.speakOver = false;
                        }
                        break;
                    case "zhangyukaixin":
                        self.zhangyu.setAnimation(1,"zhangyutumozhi",false);
                        self.scheduleOnce(function(){
                            ddPlayEffect("effect","res/zhangyu/audio/effect/pengmozhi.mp3",false);
                        },0.7);
                        break;
                    case "zhangyuhuxi":
                        break;
                    case "zhangyutumozhi":
                        //发送信号使得所有小鱼变黑,所有小鱼变白后发送信号使得章鱼开心
                        this.setAnimation(1,"zhangyuhuxi",true);
                        break;
                    default :
                        break;
                }
            }else{
                cc.log("completed ! tackEntry is null");
            }
        });
        this.zhangyu.setEventListener(function(trackEntry,event){
            if(trackEntry){
                var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";
                var loopCount = Math.floor(trackEntry.trackTime / trackEntry.animationEnd);
                cc.log("event ! current trackEntry index is "+trackEntry.trackIndex+" and trackEntry name is " + animationName +" and event.data.name = "+event.data.name+"event.intvalue:%d,event.floatvalue:%d,event.stringvalue",event.intValue,event.floatValue,event.stringValue);
            }else{
                cc.log("event ! tackEntry is null");
            }
        });

        this.zhangyuclick = new cc.Sprite("res/200x200.png",cc.rect(0,0,140,170));
        this.zhangyuclick.setPosition(-10,190);
        this.zhangyuclick.setVisible(false);
        this.zhangyu.addChild(this.zhangyuclick);
    },

    addtestListener: function () {
        var self = this;
        this.sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if (cc.rectContainsPoint(rect, locationInNode) && zhangyuTouchCouldEnter) {
                    cc.log("tumozhi");
                    zhangyuTouchCouldEnter = false;
                    self.zhangyu.setAnimation(1,"zhangyutumozhi",false);
                    ddStopAllAudios();
                    ddPlayEffect("effect","res/zhangyu/audio/effect/pengmozhi.mp3",false);
                    // self.addtumozhi();
                }
                return false;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {

            }
        });
        cc.eventManager.addListener(this.sprite_listener.clone(), this.zhangyuclick);
    },
    unregisterAllEvents:function(){
        cc.eventManager.removeCustomListeners("tell_xiaohongyu_black");
        cc.eventManager.removeCustomListeners("tell_zhangyu_happy");
    },
    releaseRes:function(){
        ddStopAllAudios();
        zhangyuTouchCouldEnter = true;
        this.unregisterAllEvents();
        this.cleanScene();
    },
    cleanScene:function(){
        this.unscheduleAllCallbacks();
        this.zhangyu.stopAllActions();
        closeStarAd(this.star_ad);
        for(var i = 0;i < 5;i ++){
            this.xiaoyu[i].stopAllActions();
        }
        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
    }
});







var ZhangyuScene = cc.Scene.extend({
    ctor:function () {
        this._super();
        umengEvent("fish_type", "ZhangYu");
        ddStopAllAudios();
        cc.audioEngine.setMusicVolume(1);
        cc.audioEngine.setEffectsVolume(1);
        var layer = new ZhangyuLaye();
        this.addChild(layer);
    },
    onEnter:function(){
        this._super();
        cc.textureCache.removeAllTextures();
        cc.spriteFrameCache.removeSpriteFrames();
    }
});

