var GlobalSceneIndex = 1;//1,2,3
var GlobalDragonNum = 2;//2,3,4
var GlobalKapaiScene = null;
var KapaiLayer = cc.Layer.extend({
	ctor:function (dragonnum,sceneIndex) {
		this._super();

		this.sceneIndex = sceneIndex;
		this.dragonnum = dragonnum;
		var back = new cc.Sprite("res/kapai/scene"+this.sceneIndex+"/background.jpg");
		var size = cc.winSize;
        back.x = size.width / 2;
        back.y = size.height / 2;
        this.addChild(back);
        resetScale(back);

		this.layer1 = new Layers(this.dragonnum,this.sceneIndex); //dragonnum,sceneindex/////2/3/4--1/2/3
		this.addChild(this.layer1);

        if(!isPad()){
		    showStarAd(this, this.star_ad, cc.p(cc.winSize.width - 80, -20));
		}
		this.addBackListener();
		//this.addHomeListener();
		return true;
	},
	addBackListener:function(){
		var self = this;
		cc.eventManager.addListener({
			event: cc.EventListener.KEYBOARD,
			onKeyReleased: function(keyCode, event) {
				if (keyCode == cc.KEY.back) {
					ddStopAllEffect();
					GlobalSceneIndex = 1;//1,2,3
					GlobalDragonNum = 2;//2,3,4
					cc.director.runScene(new HomeScene());
				}
				else if (keyCode == cc.KEY.menu) {

				}
			}}, this);
	},
	onExitTransitionDidStart:function(){
	if(!isPad()){
         closeStarAd(this.star_ad);
         this.star_ad = null;
     }
    }
});

var KapaiScene = cc.Scene.extend({
	onEnter:function (sceneIndex) {
		this._super();
		ddStopAllEffect();
		ddPlayEffect("music", "res/kapai/common/background.mp3", true);
		GlobalKapaiScene = this;
		this.sceneIndex = sceneIndex;
		setDragon234();

		var layer = new KapaiLayer(GlobalDragonNum,GlobalSceneIndex);
		this.addChild(layer);

		var layer2 = new StarLayer();
		this.addChild(layer2,10);
	}
});

