var GlobalKapaiLayer = null;

var Layers = cc.Layer.extend({
	arry_card_item:null,
	pre_card:null,
	cur_sel_num:null,
	arry_sprite_listener:null,
	ctor:function(dragonNum,sceneIndex){
		this._super();
		this.addHomeListener();
		this.createListener();
		GlobalKapaiLayer = this;
		this.cards = [];
		this.sceneIndex = sceneIndex;
		this.cardsNum = 2 * dragonNum;

		this._dragonNum = dragonNum;


		this.dragonsNames4 = [];
		this.dragonsNames6 = [];
		this.dragonsNames8 = [];
		this.switchDragons();
	},
	addHomeListener:function(){
		var self = this;
		cc.log("addHomeListener");
		this.menu_home = new cc.Sprite("res/kapai/common/home.png");
		this.menu_home.setGlobalZOrder(65535);
		this.menu_home.x = 90;
		this.menu_home.y = cc.winSize.height - 90;
		this.addChild(this.menu_home,65535);

		this.sprite_listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			swallowTouches: false,
			onTouchBegan: function (touch, event) {
				var target = event.getCurrentTarget();
				var locationInNode = target.convertToNodeSpace(touch.getLocation());

				var s = target.getContentSize();
				var rect = cc.rect(0, 0, s.width, s.height);
				if (cc.rectContainsPoint(rect, locationInNode)) {
					ddStopAllEffect();
					self.menu_home.runAction(cc.sequence(
							cc.scaleTo(0.05, 0.85, 0.85),
							cc.scaleTo(0.05, 0.75, 0.75),
							cc.scaleTo(0.05, 0.8, 0.8),
							cc.callFunc(function() {
								GlobalSceneIndex = 1;//1,2,3
								GlobalDragonNum = 2;//2,3,4
								cc.director.runScene(new HomeScene());
							}.bind(self))
					));
					return false;
				}
				return false;
			}
		});
		cc.eventManager.addListener(this.sprite_listener, this.menu_home);
	},
	createListener:function(){
		var self = this;
		this.listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			swallowTouches: false,
			onTouchBegan: function (touch, event) {
				var target = event.getCurrentTarget();
				var locationInNode = target.convertToNodeSpace(touch.getLocation());

				var s = target.getContentSize();
				var rect = cc.rect(0, 0, s.width, s.height);


				if (cc.rectContainsPoint(rect, locationInNode)) {
					if ((self.pre_card && self.pre_card == target) || target.isOpen()) {
						return false;
					}
					self.cur_sel_num++;
					cc.log("cur sel num is " + self.cur_sel_num);
					switch (self.cur_sel_num) {
					case 1:
					{
						ddPlayEffect("effect", "res/kapai/common/front.mp3", false);
						self.pre_card = target;
						self.pre_card.setOpen(true);
						self.pre_card.turnOver(true);						
						break;
					}
					case 2:
					{
						if (!self.pre_card) {
							return false;
						} else {
							ddPlayEffect("effect", "res/kapai/common/front.mp3", false);
							target.turnOver(true);
							self.checkTarget(self.pre_card, target);
						}
						break;
					}
					default:
						break;
					}

					return false;
				}
				return false;
			}
		});
	},
	checkTarget:function(card_pre, card_tar){
		card_tar.setOpen(true);
		
		if (card_pre.dragonName == card_tar.dragonName) {
			ddPlayEffect("effect", "res/kapai/common/success.mp3", false);
			cc.log("card is same");
			this.pre_card = null;
			this.cur_sel_num = 0;
			this.ischangescene();
			//一样
		} else {
			card_pre.shake();
			card_tar.shake(function(){				
				cc.log("card is not same");
				card_pre.turnOver(false);
				card_tar.turnOver(false);
				
				console.log("reset sel num");				
				card_pre.setOpen(false);
				card_tar.setOpen(false);				
				this.pre_card = null;
				this.cur_sel_num = 0;
			}.bind(this));
		}
	},
	ischangescene:function(){
		var self = this;
		GlobalKapaiLayer.cardsNum -= 2;
		if(0 == GlobalKapaiLayer.cardsNum){
			cc.log("游戏结束了！");   
			GlobalStarLayer.dropStar(GlobalDragonNum - 1);
//			var GlobalSceneIndex = 3;//1,2,3
//			var GlobalDragonNum = 4;//2,3,4
			GlobalDragonNum ++;
			if(GlobalDragonNum > 4){
				GlobalSceneIndex ++;
				if(GlobalSceneIndex > 3){
					cc.log("三个场景所有游戏全完了");
					GlobalKapaiLayer.celebrate2();					
				}else{	
					GlobalDragonNum = 2;
					GlobalKapaiLayer.celebrate();
				}
			}else{
				self.scheduleOnce(function(){
				    cc.eventManager.removeListener(self.sprite_listener);
				    self.menu_home.setVisible(false);
					var layer = new KapaiLayer(GlobalDragonNum,GlobalSceneIndex);
					GlobalKapaiScene.addChild(layer);
				},1);
			}
		}
	},
	switchDragons:function(){
		switch(this._dragonNum){
		case 2:
			this.processDragon2();
			break;
		case 3:
			this.processDragon3();
			break;
		case 4:
			this.processDragon4();
			break;
		default:
			this.processDragon2();
		break;
		}
	},
	processDragon2:function(){
		this.dragonsNames4 = retDragon234RandX2(2);
		for(var i = 0;i < 4;i ++){
			this.cards[i] = new Card(this.dragonsNames4[i],this.sceneIndex); 
			this.cards[i].setScale(0.85);
			cc.eventManager.addListener(this.listener.clone(), this.cards[i]);
			this.addChild(this.cards[i]);
			if(isPad()){
			    if(0 == Math.floor(i / 2)){
				    this.cards[i].setPosition(470 + (i % 2) * 206 - 65,175);
			    }else{
				    this.cards[i].setPosition(470 + (i % 2) * 206 - 65,375);
			    }
			}else{
			    if(0 == Math.floor(i / 2)){
            	    this.cards[i].setPosition(470 + (i % 2) * 206,160);
            	}else{
            		this.cards[i].setPosition(470 + (i % 2) * 206,375);
            	}
			}
		}
	},
	processDragon3:function(){
		this.dragonsNames6 = retDragon234RandX2(3);
		for(var i = 0;i < 6;i ++){
			this.cards[i] = new Card(this.dragonsNames6[i],this.sceneIndex);
			this.cards[i].setScale(0.85);
			cc.eventManager.addListener(this.listener.clone(), this.cards[i]);
			this.addChild(this.cards[i]);
			if(isPad()){
			    if(0 == Math.floor(i / 3)){
				    this.cards[i].setPosition(360 + (i % 3) * 206 - 55,175);
			    }else{
				    this.cards[i].setPosition(360 + (i % 3) * 206 - 55,375);
			    }
			}else{
			    if(0 == Math.floor(i / 3)){
            	    this.cards[i].setPosition(360 + (i % 3) * 206,160);
            	}else{
            		this.cards[i].setPosition(360 + (i % 3) * 206,375);
            	}
			}
		}
	},
	processDragon4:function(){
		this.dragonsNames8 = retDragon234RandX2(4);
		for(var i = 0;i < 8;i ++){
			this.cards[i] = new Card(this.dragonsNames8[i],this.sceneIndex);
			this.cards[i].setScale(0.85);
			cc.eventManager.addListener(this.listener.clone(), this.cards[i]);
			this.addChild(this.cards[i]);
			if(isPad()){
			    if(0 == Math.floor(i / 4)){
				    this.cards[i].setPosition(262 + (i % 4) * 206 - 46,175);
			    }else{
				    this.cards[i].setPosition(262 + (i % 4) * 206 - 46,375);
			    }
			}else{
			    if(0 == Math.floor(i / 4)){
          		    this.cards[i].setPosition(262 + (i % 4) * 206,160);
                }else{
       			    this.cards[i].setPosition(262 + (i % 4) * 206,375);
            	}
			}
		}
	},
	showFireworkDuoduoPumpkinAnimation : function(){
		var size = cc.winSize;

		//南瓜
		this.sprite_pumpkin = new cc.Sprite("res/kapai/choose/pumpkin/pumpkin1.png");
		this.sprite_pumpkin_begin_pos = cc.p(size.width / 2,-size.height / 2.4);
		this.sprite_pumpkin_end_pos = cc.p(size.width / 2,size.height / 2.4);
		this.sprite_pumpkin.x = this.sprite_pumpkin_begin_pos.x;
		this.sprite_pumpkin.y = this.sprite_pumpkin_begin_pos.y;
		this.addChild(this.sprite_pumpkin, 8000);
		//多多
		this.sprite_duoduo = new cc.Sprite("res/kapai/choose/duoduo/duoduo1.png");
		this.sprite_duoduo_begin_pos = cc.p(size.width / 2,-size.height / 5 - 20);
		this.sprite_duo_end_pos = cc.p(size.width / 2,size.height / 5 + 20);
		this.sprite_duoduo.x = this.sprite_duoduo_begin_pos.x;
		this.sprite_duoduo.y = this.sprite_duoduo_begin_pos.y;
		this.addChild(this.sprite_duoduo, 8000);

		//移动的多多
		this.animation_duoduo = new cc.Animation.create();
		this.animation_duoduo.setRestoreOriginalFrame(false);
		this.animation_duoduo.setDelayPerUnit(0.08);
		for(var n_index = 1; n_index <= 12; ++n_index){
			this.animation_duoduo.addSpriteFrameWithFile("res/kapai/choose/duoduo/duoduo" + n_index + ".png");
		}
		this.animation_duoduo.retain();
		var duoduo_action2 = cc.sequence(cc.moveTo(1, this.sprite_duo_end_pos).easing(cc.easeInOut(2)),
				cc.moveTo(1, this.sprite_duoduo_begin_pos).easing(cc.easeInOut(2))

		);

		//移动的南瓜
		this.animation_pumpkin = new cc.Animation.create();
		this.animation_pumpkin.setRestoreOriginalFrame(false);
		this.animation_pumpkin.setDelayPerUnit(0.08);
		for(var n_index = 1; n_index <= 9; ++n_index){
			this.animation_pumpkin.addSpriteFrameWithFile("res/kapai/choose/pumpkin/pumpkin" + n_index + ".png");
		}
		this.animation_pumpkin.retain();
		var pumpkin_action2 = cc.sequence(cc.moveTo(1, this.sprite_pumpkin_end_pos).easing(cc.easeInOut(2)),
				cc.moveTo(1, this.sprite_pumpkin_begin_pos).easing(cc.easeInOut(2))

		);
		//多多
		this.sprite_duoduo.runAction(duoduo_action2);
		this.sprite_duoduo.runAction(cc.animate(this.animation_duoduo));

		//南瓜
		this.sprite_pumpkin.runAction(pumpkin_action2.repeat(1));
		this.sprite_pumpkin.runAction(cc.RepeatForever(cc.animate(this.animation_pumpkin)));
	},
	celebrate:function(){
		this.showFireworkDuoduoPumpkinAnimation();

		var size = cc.winSize;
		var particleSystem = new cc.ParticleSystem("res/kapai/choose/demo6.plist");
		ddPlayEffect("effect", "res/kapai/common/ye.mp3", false);
		//particleSystem.setAutoRemoveOnFinish(true);
		this.addChild(particleSystem, 11000);
		particleSystem.duration = 1;
		particleSystem.setRotation(180);
		particleSystem.x = size.width / 2;
		particleSystem.y = size.height / 2;

		var self = this;
		this.runAction(cc.Sequence.create( cc.DelayTime.create(1.9), cc.CallFunc.create(function () {
			randomTransitionScene(1,new KapaiScene(GlobalSceneIndex));
		})));
	},
	celebrate2:function(){
		this.showFireworkDuoduoPumpkinAnimation();

		var size = cc.winSize;
		var particleSystem = new cc.ParticleSystem("res/kapai/choose/demo6.plist");
		ddPlayEffect("effect", "res/kapai/common/ye.mp3", false);
		//particleSystem.setAutoRemoveOnFinish(true);
		this.addChild(particleSystem, 11000);
		particleSystem.duration = 1;
		particleSystem.setRotation(180);
		particleSystem.x = size.width / 2;
		particleSystem.y = size.height / 2;

		var self = this;
		this.runAction(cc.Sequence.create( cc.DelayTime.create(2.1), cc.CallFunc.create(function () {
//			randomTransitionScene(1,new KapaiScene(GlobalSceneIndex));
			GlobalSceneIndex = 1;//1,2,3
			GlobalDragonNum = 2;//2,3,4
//			cc.director.runScene(new HomeScene());
            cc.director.runScene(new KapaiScene());
		})));
	}
});

var GlobalStarLayer = null;
var StarLayer = cc.Layer.extend({
	ctor:function(){
		this._super();
		GlobalStarLayer = this;
		this.stars_static = [];
		this.stars_dynamic = [];
		this.addStars();
	},
	addStars:function(){
	if(!isPad()){
		for(var i = 0;i < 3;i ++){
			this.stars_static[i] = new cc.Sprite("res/kapai/common/star_an.png");
			this.addChild(this.stars_static[i]);
			if(0 == i){
				this.stars_static[i].setPosition(1136/2 - 100,640-110);
			}else if(1 == i){
				this.stars_static[i].setPosition(1136/2,640-70);
			}else{
				this.stars_static[i].setPosition(1136/2 + 100,640-110);
			}
		}
		for(var i = 0;i < 3;i ++){
			this.stars_dynamic[i] = new cc.Sprite("res/kapai/common/star_liang.png");
			this.addChild(this.stars_dynamic[i]);
			if(0 == i){
				this.stars_dynamic[i].setPosition(1136/2 - 100,640-110 + 180);
			}else if(1 == i){
				this.stars_dynamic[i].setPosition(1136/2,640-70 + 180);
			}else{
				this.stars_dynamic[i].setPosition(1136/2 + 100,640-110 + 180);
			}
		}
    }else{
            for(var i = 0;i < 3;i ++){
    			this.stars_static[i] = new cc.Sprite("res/kapai/common/star_an.png");
    			this.addChild(this.stars_static[i]);
    			if(0 == i){
    				this.stars_static[i].setPosition(1024/2 - 100,768-110);
    			}else if(1 == i){
    				this.stars_static[i].setPosition(1024/2,768-70);
    			}else{
    				this.stars_static[i].setPosition(1024/2 + 100,768-110);
    			}
    		}
    		for(var i = 0;i < 3;i ++){
    			this.stars_dynamic[i] = new cc.Sprite("res/kapai/common/star_liang.png");
    			this.addChild(this.stars_dynamic[i]);
    			if(0 == i){
    				this.stars_dynamic[i].setPosition(1024/2 - 100,768-110 + 180);
    			}else if(1 == i){
    				this.stars_dynamic[i].setPosition(1024/2,768-70 + 180);
    			}else{
    				this.stars_dynamic[i].setPosition(1024/2 + 100,768-110 + 180);
    			}
    		}
    }
//		this.dropStar(1);
//		this.dropStar(2);
//		this.dropStar(3);
	},
	dropStar:function(index){//1,2,3
		var idx = index - 1; 
		this.stars_dynamic[idx].runAction(
				cc.spawn(
						cc.moveBy(0.3, 0, -180).easing(cc.easeBackIn(1)),
						cc.sequence(cc.delayTime(0.2),cc.callFunc(function(){
							ddPlayEffect("effect","res/kapai/common/effect.mp3",false);
						}))
				)
		); 
	}
});