//function ddPlayEffect(method, url, loop) {
//	var audioid = '';
//
//	if (method == 'effect'){
//		cc.audioEngine.playEffect(url, loop);
//	}else if(cc.sys.os == cc.sys.OS_ANDROID || method == 'music') {
//		ddStopAllAudios();
//		cc.audioEngine.playMusic(url, loop);
//	} else {
//		ddStopAllAudios();
//		audioid = cc.audioEngine.playEffect(url, loop);
//	}
//
//	return audioid;
//}

function ddStopAllAudios() {
	cc.audioEngine.stopMusic();
	cc.audioEngine.stopAllEffects();
}

function ddStopAllEffects(){
	cc.audioEngine.stopAllEffects();
}

//function addBackKeyListener(isroot, obj) {
//	cc.eventManager.addListener({
//		event: cc.EventListener.KEYBOARD,
//		onKeyReleased: function(keyCode, event) {
//			if (keyCode == cc.KEY.back) {
//				if (isroot) {
//					ddStopAllAudios();
//					cc.director.end();
//				} else {
//					ddStopAllAudios();
//					cc.director.popScene();
//				}
//			}
//		}}, obj);
//}

//在此向上

var ARRAY_EXTEND = "ARRAY_EXTEND";
Array.prototype.indexOf = function (val) {
	for(var i = 0; i < this.length; i++){
		if (this[i] == val) {
			return i;
		}
	}
	return -1;
};

Array.prototype.remove = function (val) {
	var index = this.indexOf(val);
	if (index > -1) {
		this.splice(index, 1);
	}
};

Array.prototype.reshuffle = function () {
	var length = this.length;
	for (var i = 0; i < length; i++) {
		var sidx = Math.floor((Math.random()) * (length-1));
		if (sidx != i) {
			var tmp = this[i];
			this[i] = this[sidx];
			this[sidx] = tmp;
		}
	}
};


//从1到length选出除了except的数字
randomchoose1 = function(length,except){//3,1
	var sidx = Math.floor((Math.random()) * (length)) + 1;//1,2,3
	if(sidx != except)
		return sidx;
	else
		return randomchoose1(length,except);
};
//从1到length选出除了except1和except2的数字
randomchoose2 = function(length,except1,except2){//3,1,3
	var sidx = Math.floor((Math.random()) * (length)) + 1;//1,2,3
	if((sidx != except1) && (sidx != except2))
		return sidx;
	else
		return randomchoose2(length,except1,except2);
};
//从1到length选出除了except1和except2和except3的数字
randomchoose3 = function(length,except1,except2,except3){//4,1,3,2
	var sidx = Math.floor((Math.random()) * (length)) + 1;//1,2,3
	if((sidx != except1) && (sidx != except2) && (sidx != except3))
		return sidx;
	else
		return randomchoose3(length,except1,except2,except3);
};
//从1到length选出除了except1和except2和except3和except4的数字
randomchoose4 = function(length,except1,except2,except3,except4){//5,1,3,2,4
	var sidx = Math.floor((Math.random()) * (length)) + 1;//1,2,3
	if((sidx != except1) && (sidx != except2) && (sidx != except3) && (sidx != except4))
		return sidx;
	else
		return randomchoose4(length,except1,except2,except3,except4);
};

//传统的通过单个文件的方式加载
//一个动画：number图片的张数,prefix图片前缀,start--0从0开始或者1从1开始,pngorjpg--0png1jpg,delayPerUnit每帧持续时间,obj运行动画的对象，times运行的次数,-1无限循环
function animationCreateAndRun(number,prefix,start,pngorjpg,delayPerUnit,obj,times,resumeOriginFrame){
	var animation = cc.Animation();
	animation.setDelayPerUnit(delayPerUnit);
	if(typeof(resumeOriginFrame) == "undefined")
		resumeOriginFrame = true;
	animation.setRestoreOriginalFrame(resumeOriginFrame);
	(0 == start) ? number : number += 1;
	var suffix = null;
	(0 == pngorjpg) ? (suffix = ".png") : ( suffix = ".jpg");
	for(var i = start;i <= number - 1;i ++ ){
		var fileName = prefix + i + suffix;
		animation.addSpriteFrameWithFile(fileName);
	}
	var animate = cc.animate(animation);
	if(-1 != times)
		var action = cc.repeat(animate, times);
	else
		var action = cc.repeatForever(animate);

	obj.runAction(action);
}
function animationCreate(number,prefix,start,delayPerUnit,times,resumeOriginFrame){
	var animation = cc.Animation();
	animation.setDelayPerUnit(delayPerUnit);
	if(typeof(resumeOriginFrame) == "undefined")
		resumeOriginFrame = true;
	animation.setRestoreOriginalFrame(resumeOriginFrame);
	(0 == start) ? number : number += 1;
	for(var i = start;i <= number - 1;i ++ ){
		var fileName = prefix + i + "";
		animation.addSpriteFrameWithFile(fileName);
	}
	var animate = cc.animate(animation);
	if(-1 != times)
		var action = cc.repeat(animate, times);
	else
		var action = cc.repeatForever(animate);

	return action;
}
function animationCreate_custom(number,prefix,start,delayPerUnit,times,resumeOriginFrame){
	var animation = cc.Animation();
	animation.setDelayPerUnit(delayPerUnit);
	if(typeof(resumeOriginFrame) == "undefined")
		resumeOriginFrame = true;
	animation.setRestoreOriginalFrame(resumeOriginFrame);
	(0 == start) ? number : number += 1;
	for(var i = start;i <= number - 1;i ++ ){
		var fileName = prefix + i + "";
		animation.addSpriteFrameWithFile(fileName);
	}
	var animate = cc.animate(animation);
	if(-1 != times)
		var action = cc.repeat(cc.spawn(animate,cc.callFunc(function(){
			ddPlayEffect("res/scene4/audio/effect/monkey_sleep.mp3");
		})), times);
	else
		var action = cc.repeatForever(animate);

	return action;
}
function animationCreateAddTag(number,prefix,start,pngorjpg,delayPerUnit,times,resumeOriginFrame,tag){
	var animation = cc.Animation();
	animation.setDelayPerUnit(delayPerUnit);
	if(typeof(resumeOriginFrame) == "undefined")
		resumeOriginFrame = true;
	animation.setRestoreOriginalFrame(resumeOriginFrame);
	(0 == start) ? number : number += 1;
	var suffix = null;
	(0 == pngorjpg) ? (suffix = ".png") : ( suffix = ".jpg");
	for(var i = start;i <= number - 1;i ++ ){
		var fileName = prefix + i + suffix;
		animation.addSpriteFrameWithFile(fileName);
	}
	var animate = cc.animate(animation);
	if(-1 != times)
		var action = cc.repeat(animate, times);
	else
		var action = cc.repeatForever(animate);

	action.setTag(tag);
	return action;
}
//两个动画并行：number图片的张数,prefix图片前缀,start--0从0开始或者1从1开始,pngorjpg--0png1jpg,delayPerUnit每帧持续时间,obj运行动画的对象，times运行的次数,-1无限循环,duration是moveto的持续时间，position结束位置,resumeOriginFrame动作完成后是否恢复原始帧true或者false
function animationCreateAndRun2(number,prefix,start,pngorjpg,delayPerUnit,object,times,duration,position,resumeOriginFrame){
	var animation = cc.Animation();
	animation.setDelayPerUnit(delayPerUnit);
	if(typeof(resumeOriginFrame) == "undefined")
		resumeOriginFrame = false;
	animation.setRestoreOriginalFrame(resumeOriginFrame);
	(0 == start) ? number : number += 1;
	var suffix = null;
	(0 == pngorjpg) ? (suffix = ".png") : ( suffix = ".jpg");
	for(var i = start;i <= number - 1;i ++ ){
		var fileName = prefix + i + suffix;
		animation.addSpriteFrameWithFile(fileName);
	}
	var animate = cc.animate(animation);
	if(-1 != times)
		var action = cc.repeat(animate, times);
	else
		var action = cc.repeatForever(animate);


	var action2 = cc.moveTo(duration, position);
	object.runAction(cc.spawn(action,action2));
}


function addSelectLayer(obj){
	obj.isSelectLayerVisible = false;
	obj.selectLayer = new GameSelectLayer();
	obj.addChild(obj.selectLayer,100);
}
//加载home菜单(只添加一项)
function loadHomeMenu(obj,zorder,locationNormal,locationHigh){
	var arrayMenu = [];

	var homeItem = cc.MenuItemImage(
			locationNormal,
			locationHigh,
			function(){
				if(obj.menulayerVisible){
					obj.setMenuLayerVisible(false);
				}else{
					obj.setMenuLayerVisible(true);
				}
			},
			obj
	);
	homeItem.attr({
		x: 75,
		y: GH - 60,
		anchorX: 0.5,
		anchorY: 0.5
	});
	arrayMenu[0] = homeItem;

	var homeMenu = cc.Menu(arrayMenu);
	homeMenu.setPosition(0,0);
	obj.addChild(homeMenu,zorder);
}

function getRand1ToN(n){
	return Math.ceil(Math.random()*n);
}
function getRand0ToN(n){
	return Math.floor(Math.random()*(1+n));
}
function getRand0To1(n){
	return Math.random();
}
//number, prefix, delayPerUnit, times, resumeOriginFrame
var PathObj = cc.Class.extend({
	number:null,
	prefix:null,
	delayPerUnit:null,
	times:null,
	resumeOriginFrame:null,
	ctor:function(number,prefix, delayPerUnit, times, resumeOriginFrame){
		this.number = number;
		this.prefix = prefix;
		this.delayPerUnit = delayPerUnit;
		this.times = times;
		this.resumeOriginFrame = resumeOriginFrame;
	},
});
var BoxObj = cc.Class.extend({
	x:null,
	y:null,
	width:null,
	height:null,
	ctor:function(x,y, width, height){
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
	},
});


function isPad(){
    if(cc.sys.os == cc.sys.OS_ANDROID){
    		var strSize = jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "getScreenSize", "()Ljava/lang/String;");
    		if(strSize && strSize.length){
                var parse_result = JSON.parse(strSize);
                var width = parseInt(parse_result.width);
                var height = parseInt(parse_result.height);
                if(width *3 == height * 4){
                    return true;
                }
            }
            return false;
    }else if(cc.sys.os == cc.sys.OS_IOS){
    		return false;
    }
}
function resetScale(sprite){
    if(isPad()){
        sprite.setScale(1.2,1.2);
    }
}

